
;CodeVisionAVR C Compiler V1.25.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "02_3310.vec"
	.INCLUDE "02_3310.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 //ATmega8
;       2 //4,000000 MHz
;       3 
;       4 #include <mega8.h>
;       5 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;       6 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;       7 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;       8 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;       9 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      10 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      11 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      12 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      13 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      14 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      15 	#endif
	#endif
;      16 #include <delay.h>
;      17 #include <stdio.h>
;      18 #include <spi.h>
;      19 //  Mega8 port B pinout for LCD.
;      20 #define LCD_DC_PIN      PORTB.0  //D/C
;      21 #define LCD_CE_PIN      PORTB.2  //SCE
;      22 #define SPI_MOSI_PIN    PORTB.3  //SDIN
;      23 #define LCD_RST_PIN     PORTB.4  //RES
;      24 #define SPI_CLK_PIN     PORTB.5  //SCLK
;      25 
;      26 //        
;      27 unsigned char   lcd_buf[14];		//     LCD
_lcd_buf:
	.BYTE 0xE
;      28 unsigned char   LcdCache [504];	//   (504  816 )
_LcdCache:
	.BYTE 0x1F8
;      29 unsigned int    LcdCacheIdx;     //Cache index
;      30 unsigned int    adc_data;        //  
;      31 unsigned int    ind;             //   . .
;      32 unsigned int    Vtis,Vsot,Vdes,Ved;
_Vdes:
	.BYTE 0x2
_Ved:
	.BYTE 0x2
;      33 
;      34 #define LCD_CMD         0
;      35 #define LCD_DATA        1
;      36 
;      37 //void LcdChrBold (int ch);							      ,   )
;      38 //void LcdStringBold (unsigned char x, unsigned char y);    
;      39 //void LcdChrBig (int ch);							      , 
;      40 //void LcdStringBig (unsigned char x, unsigned char y);	  
;      41 
;      42 //ASCII
;      43 const char table[455]=

	.CSEG
;      44 {
;      45 0x00, 0x00, 0x00, 0x00, 0x00,// 20 space
;      46 0x00, 0x00, 0x5F, 0x00, 0x00,// 21 !
;      47 0x00, 0x07, 0x00, 0x07, 0x00,// 22 "
;      48 0x14, 0x7F, 0x14, 0x7F, 0x14,// 23 #
;      49 0x24, 0x2A, 0x7F, 0x2A, 0x12,// 24 $
;      50 0x23, 0x13, 0x08, 0x64, 0x62,// 25 %
;      51 0x36, 0x49, 0x55, 0x22, 0x50,// 26 &
;      52 0x00, 0x05, 0x03, 0x00, 0x00,// 27 '
;      53 0x00, 0x1C, 0x22, 0x41, 0x00,// 28 (
;      54 0x00, 0x41, 0x22, 0x1C, 0x00,// 29 )
;      55 0x14, 0x08, 0x3E, 0x08, 0x14,// 2a *
;      56 0x08, 0x08, 0x3E, 0x08, 0x08,// 2b +
;      57 0x00, 0x50, 0x30, 0x00, 0x00,// 2c ,
;      58 0x08, 0x08, 0x08, 0x08, 0x08,// 2d -
;      59 0x00, 0x60, 0x60, 0x00, 0x00,// 2e .
;      60 0x20, 0x10, 0x08, 0x04, 0x02,// 2f /
;      61 0x3E, 0x51, 0x49, 0x45, 0x3E,// 30 0
;      62 0x00, 0x42, 0x7F, 0x40, 0x00,// 31 1
;      63 0x42, 0x61, 0x51, 0x49, 0x46,// 32 2
;      64 0x21, 0x41, 0x45, 0x4B, 0x31,// 33 3
;      65 0x18, 0x14, 0x12, 0x7F, 0x10,// 34 4
;      66 0x27, 0x45, 0x45, 0x45, 0x39,// 35 5
;      67 0x3C, 0x4A, 0x49, 0x49, 0x30,// 36 6
;      68 0x01, 0x71, 0x09, 0x05, 0x03,// 37 7
;      69 0x36, 0x49, 0x49, 0x49, 0x36,// 38 8
;      70 0x06, 0x49, 0x49, 0x29, 0x1E,// 39 9
;      71 0x00, 0x36, 0x36, 0x00, 0x00,// 3a :
;      72 0x00, 0x56, 0x36, 0x00, 0x00,// 3b ;
;      73 0x08, 0x14, 0x22, 0x41, 0x00,// 3c <
;      74 0x14, 0x14, 0x14, 0x14, 0x14,// 3d =
;      75 0x00, 0x41, 0x22, 0x14, 0x08,// 3e >
;      76 0x02, 0x01, 0x51, 0x09, 0x06,// 3f ?
;      77 0x32, 0x49, 0x79, 0x41, 0x3E,// 40 @
;      78 0x7E, 0x11, 0x11, 0x11, 0x7E,// 41 A
;      79 0x7F, 0x49, 0x49, 0x49, 0x36,// 42 B
;      80 0x3E, 0x41, 0x41, 0x41, 0x22,// 43 C
;      81 0x7F, 0x41, 0x41, 0x22, 0x1C,// 44 D
;      82 0x7F, 0x49, 0x49, 0x49, 0x41,// 45 E
;      83 0x7F, 0x09, 0x09, 0x09, 0x01,// 46 F
;      84 0x3E, 0x41, 0x49, 0x49, 0x7A,// 47 G
;      85 0x7F, 0x08, 0x08, 0x08, 0x7F,// 48 H
;      86 0x00, 0x41, 0x7F, 0x41, 0x00,// 49 I
;      87 0x20, 0x40, 0x41, 0x3F, 0x01,// 4a J
;      88 0x7F, 0x08, 0x14, 0x22, 0x41,// 4b K
;      89 0x7F, 0x40, 0x40, 0x40, 0x40,// 4c L
;      90 0x7F, 0x02, 0x0C, 0x02, 0x7F,// 4d M
;      91 0x7F, 0x04, 0x08, 0x10, 0x7F,// 4e N
;      92 0x3E, 0x41, 0x41, 0x41, 0x3E,// 4f O
;      93 0x7F, 0x09, 0x09, 0x09, 0x06,// 50 P
;      94 0x3E, 0x41, 0x51, 0x21, 0x5E,// 51 Q
;      95 0x7F, 0x09, 0x19, 0x29, 0x46,// 52 R
;      96 0x46, 0x49, 0x49, 0x49, 0x31,// 53 S
;      97 0x01, 0x01, 0x7F, 0x01, 0x01,// 54 T
;      98 0x3F, 0x40, 0x40, 0x40, 0x3F,// 55 U
;      99 0x1F, 0x20, 0x40, 0x20, 0x1F,// 56 V
;     100 0x3F, 0x40, 0x38, 0x40, 0x3F,// 57 W
;     101 0x63, 0x14, 0x08, 0x14, 0x63,// 58 X
;     102 0x07, 0x08, 0x70, 0x08, 0x07,// 59 Y
;     103 0x61, 0x51, 0x49, 0x45, 0x43,// 5a Z
;     104 0x00, 0x7F, 0x41, 0x41, 0x00,// 5b [
;     105 0x02, 0x04, 0x08, 0x10, 0x20,// 5c Yen Currency Sign
;     106 0x00, 0x41, 0x41, 0x7F, 0x00,// 5d ]
;     107 0x04, 0x02, 0x01, 0x02, 0x04,// 5e ^
;     108 0x40, 0x40, 0x40, 0x40, 0x40,// 5f _
;     109 0x00, 0x01, 0x02, 0x04, 0x00,// 60 `
;     110 0x20, 0x54, 0x54, 0x54, 0x78,// 61 a
;     111 0x7F, 0x48, 0x44, 0x44, 0x38,// 62 b
;     112 0x38, 0x44, 0x44, 0x44, 0x20,// 63 c
;     113 0x38, 0x44, 0x44, 0x48, 0x7F,// 64 d
;     114 0x38, 0x54, 0x54, 0x54, 0x18,// 65 e
;     115 0x08, 0x7E, 0x09, 0x01, 0x02,// 66 f
;     116 0x0C, 0x52, 0x52, 0x52, 0x3E,// 67 g
;     117 0x7F, 0x08, 0x04, 0x04, 0x78,// 68 h
;     118 0x00, 0x44, 0x7D, 0x40, 0x00,// 69 i
;     119 0x20, 0x40, 0x44, 0x3D, 0x00,// 6a j
;     120 0x7F, 0x10, 0x28, 0x44, 0x00,// 6b k
;     121 0x00, 0x41, 0x7F, 0x40, 0x00,// 6c l
;     122 0x7C, 0x04, 0x18, 0x04, 0x78,// 6d m
;     123 0x7C, 0x08, 0x04, 0x04, 0x78,// 6e n
;     124 0x38, 0x44, 0x44, 0x44, 0x38,// 6f o
;     125 0x7C, 0x14, 0x14, 0x14, 0x08,// 70 p
;     126 0x08, 0x14, 0x14, 0x18, 0x7C,// 71 q
;     127 0x7C, 0x08, 0x04, 0x04, 0x08,// 72 r
;     128 0x48, 0x54, 0x54, 0x54, 0x20,// 73 s
;     129 0x04, 0x3F, 0x44, 0x40, 0x20,// 74 t
;     130 0x3C, 0x40, 0x40, 0x20, 0x7C,// 75 u
;     131 0x1C, 0x20, 0x40, 0x20, 0x1C,// 76 v
;     132 0x3C, 0x40, 0x30, 0x40, 0x3C,// 77 w
;     133 0x44, 0x28, 0x10, 0x28, 0x44,// 78 x
;     134 0x0C, 0x50, 0x50, 0x50, 0x3C,// 79 y
;     135 0x44, 0x64, 0x54, 0x4C, 0x44};// 7a z
;     136 
;     137 void hex_to_dec(void)         //    hex  dec
;     138 {
_hex_to_dec:
;     139   Vtis=0;                     //  
	CLR  R10
	CLR  R11
;     140   while (ind>=1000)           // 
_0x3:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x0
	BRLO _0x5
;     141   {
;     142   ind-=1000;
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x1
;     143   Vtis++;
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
;     144   }
	RJMP _0x3
_0x5:
;     145 
;     146   Vsot=0;                     //  
	CLR  R12
	CLR  R13
;     147   while (ind>=100)            // 
_0x6:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x0
	BRLO _0x8
;     148   {
;     149   ind-=100;
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x1
;     150   Vsot++;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
;     151   }
	RJMP _0x6
_0x8:
;     152 
;     153   Vdes=0;                     //  
	LDI  R30,0
	STS  _Vdes,R30
	STS  _Vdes+1,R30
;     154   while (ind>=10)             // 
_0x9:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x0
	BRLO _0xB
;     155   {
;     156   ind-=10;
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x1
;     157   Vdes++;
	RCALL SUBOPT_0x2
	ADIW R30,1
	STS  _Vdes,R30
	STS  _Vdes+1,R31
;     158   }
	RJMP _0x9
_0xB:
;     159 
;     160   Ved=0;                      //  
	LDI  R30,0
	STS  _Ved,R30
	STS  _Ved+1,R30
;     161   while (ind>=1)              // 
_0xC:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x0
	BRLO _0xE
;     162   {
;     163   ind-=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x1
;     164   Ved++;
	LDS  R30,_Ved
	LDS  R31,_Ved+1
	ADIW R30,1
	STS  _Ved,R30
	STS  _Ved+1,R31
;     165   };
	RJMP _0xC
_0xE:
;     166 }
	RET
;     167 
;     168 void LcdSend (unsigned char data, unsigned char cmd) //Sends data to display controller
;     169 {
_LcdSend:
;     170   LCD_CE_PIN = 0;                          //Enable display controller (active low)
;	data -> Y+1
;	cmd -> Y+0
	CBI  0x18,2
;     171 
;     172   if (cmd)                                 // , 
	LD   R30,Y
	CPI  R30,0
	BREQ _0x11
;     173      LCD_DC_PIN = 1;	                       //LCD_DC_PIN = 1
	SBI  0x18,0
;     174 
;     175   else LCD_DC_PIN = 0;
	RJMP _0x14
_0x11:
	CBI  0x18,0
;     176        spi (data);                         //Send data to display controller
_0x14:
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _spi
;     177 }
	RJMP _0xF4
;     178 
;     179 void LcdUpdate (void)                      //Copies the LCD cache into the device RAM
;     180 {
_LcdUpdate:
;     181   int i;
;     182 
;     183   for (i = 0; i < 504; i++)		//  (504   816 )
	RCALL __SAVELOCR2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x18:
	__CPWRN 16,17,504
	BRGE _0x19
;     184   {
;     185     LcdSend(LcdCache[i], LCD_DATA);
	RCALL SUBOPT_0x3
	LD   R30,X
	ST   -Y,R30
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x4
;     186   }
	__ADDWRN 16,17,1
	RJMP _0x18
_0x19:
;     187 }
	RJMP _0xF5
;     188 
;     189 void LcdClear (void)    //Clears the display
;     190   {
_LcdClear:
;     191     int i;
;     192                                                 //(504   816 )
;     193 	  for (i = 0; i < 504; i++) LcdCache[i] = 0;	//   0
	RCALL __SAVELOCR2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x1B:
	__CPWRN 16,17,504
	BRGE _0x1C
	RCALL SUBOPT_0x3
	LDI  R30,LOW(0)
	ST   X,R30
;     194   }
	__ADDWRN 16,17,1
	RJMP _0x1B
_0x1C:
_0xF5:
	RCALL __LOADLOCR2P
	RET
;     195 
;     196 void LcdInit ( void )	// SPI  
;     197   {
_LcdInit:
;     198     LCD_RST_PIN = 1;   //  /
	SBI  0x18,4
;     199     delay_ms(50);      //SPI Control Register  SPCR
	RCALL SUBOPT_0x5
;     200     SPCR = 0x50;       //Enable SPI: No interrupt, MSBit first, Master mode, CPOL->0, CPHA->0, Clk/4
	LDI  R30,LOW(80)
	OUT  0xD,R30
;     201     LCD_RST_PIN = 0;   // 
	CBI  0x18,4
;     202     delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x6
	RCALL _delay_ms
;     203     LCD_RST_PIN = 1;
	SBI  0x18,4
;     204 
;     205     LCD_CE_PIN = 1;    //Disable LCD controller
	SBI  0x18,2
;     206 
;     207     LcdSend( 0x21, LCD_CMD ); 			//LCD Extended Commands
	LDI  R30,LOW(33)
	RCALL SUBOPT_0x7
;     208     LcdSend( 0x06, LCD_CMD ); 			//Set Temp coefficent
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x7
;     209     LcdSend( 0x13, LCD_CMD ); 			//LCD bias mode 1:48
	LDI  R30,LOW(19)
	RCALL SUBOPT_0x7
;     210     LcdSend( 0xAA, LCD_CMD ); 			//Set LCD Vop (Contrast)0xC5  0xC8 -   0xAA - .
	LDI  R30,LOW(170)
	RCALL SUBOPT_0x7
;     211     LcdSend (0x20, LCD_CMD );       //Horizontal addressing mode.
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x7
;     212 	  LcdSend (0x0C, LCD_CMD );       //normal mode.
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x7
;     213   };
	RET
;     214 
;     215 //Sets cursor location to xy location. Range: 1,1 .. 14,6
;     216 void LcdGotoXYFont (unsigned char x, unsigned char y)
;     217 {
_LcdGotoXYFont:
;     218   if (x <= 14 && y<= 6)
;	x -> Y+1
;	y -> Y+0
	LDD  R26,Y+1
	CPI  R26,LOW(0xF)
	BRSH _0x26
	LD   R26,Y
	CPI  R26,LOW(0x7)
	BRLO _0x27
_0x26:
	RJMP _0x25
_0x27:
;     219   LcdCacheIdx = ((int)(y)-1)*84 + ((int)(x)-1)*6;
	LD   R30,Y
	RCALL SUBOPT_0x8
	LDI  R26,LOW(84)
	LDI  R27,HIGH(84)
	RCALL __MULW12
	MOVW R22,R30
	LDD  R30,Y+1
	RCALL SUBOPT_0x8
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	RCALL __MULW12
	ADD  R30,R22
	ADC  R31,R23
	MOVW R4,R30
;     220 }
_0x25:
_0xF4:
	ADIW R28,2
	RET
;     221 
;     222 //Displays a bold character at current cursor location and increment cursor location
;     223 void LcdChrBold (int ch)
;     224 {
_LcdChrBold:
;     225   unsigned char i;
;     226   unsigned char a = 0, b = 0, c = 0;
;     227 
;     228   for ( i = 0; i < 5; i++ )
	RCALL __SAVELOCR4
;	ch -> Y+4
;	i -> R17
;	a -> R16
;	b -> R19
;	c -> R18
	LDI  R16,0
	LDI  R18,0
	LDI  R19,0
	LDI  R17,LOW(0)
_0x29:
	CPI  R17,5
	BRSH _0x2A
;     229 {
;     230   c = table[((ch*5)-160+i)];		  //    c = FontLookup[ch - 32][i] << 1;
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __MULW12
	SUBI R30,LOW(160)
	SBCI R31,HIGH(160)
	MOVW R26,R30
	RCALL SUBOPT_0x9
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_table*2)
	SBCI R31,HIGH(-_table*2)
	LPM  R18,Z
;     231 
;     232   b =  (c & 0x01) * 3;            //3  ""    
	RCALL SUBOPT_0xA
	MOV  R19,R30
;     233   b |= (c & 0x02) * 6;            //6     
	RCALL SUBOPT_0xB
	OR   R19,R30
;     234   b |= (c & 0x04) * 12;           //12
	RCALL SUBOPT_0xC
	OR   R19,R30
;     235   b |= (c & 0x08) * 24;           //24
	RCALL SUBOPT_0xD
	OR   R19,R30
;     236 
;     237   c >>= 4;
	SWAP R18
	ANDI R18,0xF
;     238   a =  (c & 0x01) * 3;            //3     
	RCALL SUBOPT_0xA
	MOV  R16,R30
;     239   a |= (c & 0x02) * 6;            //6
	RCALL SUBOPT_0xB
	OR   R16,R30
;     240   a |= (c & 0x04) * 12;            //12
	RCALL SUBOPT_0xC
	OR   R16,R30
;     241   a |= (c & 0x08) * 24;           //24
	RCALL SUBOPT_0xD
	OR   R16,R30
;     242 
;     243   LcdCache[LcdCacheIdx] = b;	    //    
	MOVW R30,R4
	SUBI R30,LOW(-_LcdCache)
	SBCI R31,HIGH(-_LcdCache)
	ST   Z,R19
;     244   LcdCache[LcdCacheIdx+1] = b;    //     LcdCache[LcdCacheIdx+1]
	MOVW R30,R4
	__ADDW1MN _LcdCache,1
	ST   Z,R19
;     245   LcdCache[LcdCacheIdx+84] = a;   //LcdCache[LcdCacheIdx+84]
	MOVW R30,R4
	__ADDW1MN _LcdCache,84
	ST   Z,R16
;     246   LcdCache[LcdCacheIdx+85] = a;   //LcdCache[LcdCacheIdx+85]
	MOVW R30,R4
	__ADDW1MN _LcdCache,85
	ST   Z,R16
;     247   LcdCacheIdx = LcdCacheIdx+2;    //   +1  +2 . +3 
	MOVW R30,R4
	ADIW R30,2
	MOVW R4,R30
;     248   }
	SUBI R17,-1
	RJMP _0x29
_0x2A:
;     249 
;     250   LcdCache[LcdCacheIdx++] = 0x00;	  //  
	RCALL SUBOPT_0xE
;     251   LcdCache[LcdCacheIdx++] = 0x00;   // 
	RCALL SUBOPT_0xE
;     252  	}
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
;     253 
;     254 //Displays a string at current cursor location
;     255 void LcdStringBold (unsigned char x, unsigned char y)
;     256 {
_LcdStringBold:
;     257 unsigned char i;
;     258 
;     259 LcdGotoXYFont (x, y);
	ST   -Y,R17
;	x -> Y+2
;	y -> Y+1
;	i -> R17
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _LcdGotoXYFont
;     260 for ( i = 0; i < 14-x; i++ )
	LDI  R17,LOW(0)
_0x2C:
	LDD  R26,Y+2
	LDI  R30,LOW(14)
	SUB  R30,R26
	CP   R17,R30
	BRSH _0x2D
;     261 
;     262 if (lcd_buf[i])
	RCALL SUBOPT_0x9
	SUBI R30,LOW(-_lcd_buf)
	SBCI R31,HIGH(-_lcd_buf)
	LD   R30,Z
	CPI  R30,0
	BREQ _0x2E
;     263 
;     264 LcdChrBold (lcd_buf[i]);
	RCALL SUBOPT_0x9
	SUBI R30,LOW(-_lcd_buf)
	SBCI R31,HIGH(-_lcd_buf)
	LD   R30,Z
	LDI  R31,0
	RCALL SUBOPT_0x6
	RCALL _LcdChrBold
;     265 }
_0x2E:
	SUBI R17,-1
	RJMP _0x2C
_0x2D:
	LDD  R17,Y+0
	ADIW R28,3
	RET
;     266 
;     267 // ADC interrupt service routine
;     268 interrupt [ADC_INT] void adc_isr(void) //   
;     269 {
_adc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     270 adc_data=ADCW; //    ads_data
	__INWR 6,7,4
;     271 ind=1000.0*adc_data*5.0/1024;
	MOVW R30,R6
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x447A0000
	RCALL __MULF12
	__GETD2N 0x40A00000
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x44800000
	RCALL __DIVF21
	RCALL __CFD1U
	MOVW R8,R30
;     272 hex_to_dec();
	RCALL _hex_to_dec
;     273 
;     274   LcdClear(); //     . .  !!!
	RCALL _LcdClear
;     275 
;     276       sprintf (lcd_buf,"V=%u,%u%u",Vtis,Vsot,Vdes);
	LDI  R30,LOW(_lcd_buf)
	LDI  R31,HIGH(_lcd_buf)
	RCALL SUBOPT_0x6
	__POINTW1FN _0,0
	RCALL SUBOPT_0x6
	MOVW R30,R10
	RCALL SUBOPT_0xF
	MOVW R30,R12
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0xF
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
;     277 	    //sprintf (lcd_buf,"V=%u,%u%u%u",Vtis,Vsot,Vdes,Ved);
;     278 		  LcdStringBold(2,3);               //  2 . 3  
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _LcdStringBold
;     279 
;     280 		  LcdUpdate();
	RCALL _LcdUpdate
;     281 
;     282 		  delay_ms(50);
	RCALL SUBOPT_0x5
;     283 };
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     284 
;     285 void main(void)
;     286 {
_main:
;     287 
;     288  DDRB=0b00111101;       //PORTB.0, PORTB.2 - PORTB.5  .
	LDI  R30,LOW(61)
	OUT  0x17,R30
;     289 PORTB=0b00101001;       //  1 .
	LDI  R30,LOW(41)
	OUT  0x18,R30
;     290 
;     291  DDRC=0b1111110;        //PC.0  .  .
	LDI  R30,LOW(126)
	OUT  0x14,R30
;     292 PORTC=0b0000000;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     293 
;     294  DDRD=0b11111111;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     295 PORTD=0b00000000;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     296 
;     297 // Analog Comparator: Off
;     298 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     299 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     300 
;     301 // 
;     302 //   101=k=32 4000/32=125    
;     303 
;     304 ADCSRA=0b10001101;   //7-  3-. 101   32
	LDI  R30,LOW(141)
	OUT  0x6,R30
;     305 
;     306 ADMUX=0b00000000;    //0-  -PC0,  
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     307 
;     308 //  
;     309 ADCSRA|=0x60;        //ADCSRA|=0x60;=0b1000000
	IN   R30,0x6
	ORI  R30,LOW(0x60)
	OUT  0x6,R30
;     310 
;     311 LcdInit();
	RCALL _LcdInit
;     312 #asm("sei")
	sei
;     313 
;     314   while (1){};
_0x2F:
	RJMP _0x2F
;     315 }
_0x32:
	RJMP _0x32

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x40
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x42
	__CPWRN 16,17,2
	BRLO _0x43
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x42:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x43:
	RJMP _0x44
_0x40:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x44:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x45:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x47
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x4B
	CPI  R18,37
	BRNE _0x4C
	LDI  R17,LOW(1)
	RJMP _0x4D
_0x4C:
	RCALL SUBOPT_0x10
_0x4D:
	RJMP _0x4A
_0x4B:
	CPI  R30,LOW(0x1)
	BRNE _0x4E
	CPI  R18,37
	BRNE _0x4F
	RCALL SUBOPT_0x10
	RJMP _0xF6
_0x4F:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x50
	LDI  R16,LOW(1)
	RJMP _0x4A
_0x50:
	CPI  R18,43
	BRNE _0x51
	LDI  R20,LOW(43)
	RJMP _0x4A
_0x51:
	CPI  R18,32
	BRNE _0x52
	LDI  R20,LOW(32)
	RJMP _0x4A
_0x52:
	RJMP _0x53
_0x4E:
	CPI  R30,LOW(0x2)
	BRNE _0x54
_0x53:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x55
	ORI  R16,LOW(128)
	RJMP _0x4A
_0x55:
	RJMP _0x56
_0x54:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x4A
_0x56:
	CPI  R18,48
	BRLO _0x59
	CPI  R18,58
	BRLO _0x5A
_0x59:
	RJMP _0x58
_0x5A:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x4A
_0x58:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x5E
	RCALL SUBOPT_0x11
	LD   R30,X
	RCALL SUBOPT_0x12
	RJMP _0x5F
_0x5E:
	CPI  R30,LOW(0x73)
	BRNE _0x61
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x13
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x62
_0x61:
	CPI  R30,LOW(0x70)
	BRNE _0x64
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x13
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x62:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x65
_0x64:
	CPI  R30,LOW(0x64)
	BREQ _0x68
	CPI  R30,LOW(0x69)
	BRNE _0x69
_0x68:
	ORI  R16,LOW(4)
	RJMP _0x6A
_0x69:
	CPI  R30,LOW(0x75)
	BRNE _0x6B
_0x6A:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	RCALL SUBOPT_0x14
	LDI  R17,LOW(5)
	RJMP _0x6C
_0x6B:
	CPI  R30,LOW(0x58)
	BRNE _0x6E
	ORI  R16,LOW(8)
	RJMP _0x6F
_0x6E:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xA0
_0x6F:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	RCALL SUBOPT_0x14
	LDI  R17,LOW(4)
_0x6C:
	SBRS R16,2
	RJMP _0x71
	RCALL SUBOPT_0x11
	RCALL __GETW1P
	RCALL SUBOPT_0x15
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x72
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x15
	LDI  R20,LOW(45)
_0x72:
	CPI  R20,0
	BREQ _0x73
	SUBI R17,-LOW(1)
	RJMP _0x74
_0x73:
	ANDI R16,LOW(251)
_0x74:
	RJMP _0x75
_0x71:
	RCALL SUBOPT_0x11
	RCALL __GETW1P
	RCALL SUBOPT_0x15
_0x75:
_0x65:
	SBRC R16,0
	RJMP _0x76
_0x77:
	CP   R17,R21
	BRSH _0x79
	SBRS R16,7
	RJMP _0x7A
	SBRS R16,2
	RJMP _0x7B
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x7C
_0x7B:
	LDI  R18,LOW(48)
_0x7C:
	RJMP _0x7D
_0x7A:
	LDI  R18,LOW(32)
_0x7D:
	RCALL SUBOPT_0x10
	SUBI R21,LOW(1)
	RJMP _0x77
_0x79:
_0x76:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x7E
_0x7F:
	CPI  R19,0
	BREQ _0x81
	SBRS R16,3
	RJMP _0x82
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x14
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xF7
_0x82:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xF7:
	ST   -Y,R30
	RCALL SUBOPT_0x16
	CPI  R21,0
	BREQ _0x84
	SUBI R21,LOW(1)
_0x84:
	SUBI R19,LOW(1)
	RJMP _0x7F
_0x81:
	RJMP _0x85
_0x7E:
_0x87:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x14
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x89:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x8B
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x15
	RJMP _0x89
_0x8B:
	CPI  R18,58
	BRLO _0x8C
	SBRS R16,3
	RJMP _0x8D
	SUBI R18,-LOW(7)
	RJMP _0x8E
_0x8D:
	SUBI R18,-LOW(39)
_0x8E:
_0x8C:
	SBRC R16,4
	RJMP _0x90
	CPI  R18,49
	BRSH _0x92
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x91
_0x92:
	RJMP _0xF8
_0x91:
	CP   R21,R19
	BRLO _0x96
	SBRS R16,0
	RJMP _0x97
_0x96:
	RJMP _0x95
_0x97:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x98
	LDI  R18,LOW(48)
_0xF8:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x99
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x16
	CPI  R21,0
	BREQ _0x9A
	SUBI R21,LOW(1)
_0x9A:
_0x99:
_0x98:
_0x90:
	RCALL SUBOPT_0x10
	CPI  R21,0
	BREQ _0x9B
	SUBI R21,LOW(1)
_0x9B:
_0x95:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x88
	RJMP _0x87
_0x88:
_0x85:
	SBRS R16,0
	RJMP _0x9C
_0x9D:
	CPI  R21,0
	BREQ _0x9F
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x12
	RJMP _0x9D
_0x9F:
_0x9C:
_0xA0:
_0x5F:
_0xF6:
	LDI  R17,LOW(0)
_0x4A:
	RJMP _0x45
_0x47:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x6
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x6
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x6
	RCALL __print_G2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_spi:
	LD   R30,Y
	OUT  0xF,R30
_0xEC:
	SBIS 0xE,7
	RJMP _0xEC
	IN   R30,0xF
	ADIW R28,1
	RET
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S4E:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	CP   R8,R30
	CPC  R9,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	__SUBWRR 8,9,30,31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LDS  R30,_Vdes
	LDS  R31,_Vdes+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDI  R26,LOW(_LcdCache)
	LDI  R27,HIGH(_LcdCache)
	ADD  R26,R16
	ADC  R27,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	RJMP _LcdSend

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LDI  R31,0
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x9:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	MOV  R30,R18
	ANDI R30,LOW(0x1)
	MOV  R26,R30
	LDI  R30,LOW(3)
	MUL  R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	MOV  R30,R18
	ANDI R30,LOW(0x2)
	MOV  R26,R30
	LDI  R30,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xC:
	MOV  R30,R18
	ANDI R30,LOW(0x4)
	MOV  R26,R30
	LDI  R30,LOW(12)
	MUL  R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	MOV  R30,R18
	ANDI R30,LOW(0x8)
	MOV  R26,R30
	LDI  R30,LOW(24)
	MUL  R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE:
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	SBIW R30,1
	SUBI R30,LOW(-_LcdCache)
	SBCI R31,HIGH(-_LcdCache)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x10:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x6
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x6
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x11:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x6
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x6
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x16:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x6
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x6
	RJMP __put_G2

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
