
;CodeVisionAVR C Compiler V1.25.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "02_3310.vec"
	.INCLUDE "02_3310.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 //ATmega8
;       2 //4,000000 MHz
;       3 
;       4 #include <mega8.h>
;       5 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;       6 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;       7 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;       8 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;       9 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      10 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      11 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      12 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      13 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      14 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      15 	#endif
	#endif
;      16 #include <delay.h>
;      17 #include <stdlib.h>
;      18 #include <stdio.h>
;      19 
;      20 //48x84 dots, 6x14 symbols
;      21 
;      22 //LCD Port & pinout setup
;      23 #define LCD_PORT PORTB
;      24 #define LCD_DDR  DDRB
;      25 
;      26 #define LCD_DC_PIN    2   //PORTB.2
;      27 #define LCD_CE_PIN    1   //PORTB.1
;      28 #define SPI_MOSI_PIN  3   //PORTB.3
;      29 #define LCD_RST_PIN   0   //PORTB.0
;      30 #define SPI_CLK_PIN   5   //PORTB.5
;      31 
;      32 //        
;      33 
;      34 unsigned char lcd_buf[14];		//     LCD
_lcd_buf:
	.BYTE 0xE
;      35 
;      36 //bit power_down = 0;			//power-down control: 0 - chip is active, 1 - chip is in PD-mode
;      37 //bit addressing = 0;			// : 0 - , 1- 
;      38 
;      39 #define LCD_X_RES 84	                          // 
;      40 #define LCD_Y_RES 48                            //102*64/8=816 
;      41 #define LCD_CACHE_SIZE   LCD_X_RES*LCD_Y_RES/8  // 84*48/8=504
;      42 
;      43 unsigned char  LcdCache [LCD_CACHE_SIZE];	//Cache buffer in SRAM 84*48 bits or 504 bytes
_LcdCache:
	.BYTE 0x1F8
;      44 unsigned int   LcdCacheIdx;              	//Cache index
;      45 
;      46 #define LCD_CMD         0
;      47 #define LCD_DATA        1
;      48 
;      49 // 
;      50 //void LcdChrBold (int ch);							                      ,   )
;      51 //void LcdStringBold (unsigned char x, unsigned char y);	    
;      52 //void LcdChrBig (int ch);							                      , 
;      53 //void LcdStringBig (unsigned char x, unsigned char y);		  
;      54 
;      55 //ASCII
;      56 const char table[0x0500] =      //1280

	.CSEG
;      57 {
;      58 0x00, 0x00, 0x00, 0x00, 0x00,// 00
;      59 0x00, 0x00, 0x5F, 0x00, 0x00,// 01
;      60 0x00, 0x07, 0x00, 0x07, 0x00,// 02
;      61 0x14, 0x7F, 0x14, 0x7F, 0x14,// 03
;      62 0x24, 0x2A, 0x7F, 0x2A, 0x12,// 04
;      63 0x23, 0x13, 0x08, 0x64, 0x62,// 05
;      64 0x36, 0x49, 0x55, 0x22, 0x50,// 06
;      65 0x00, 0x05, 0x03, 0x00, 0x00,// 07
;      66 0x00, 0x1C, 0x22, 0x41, 0x00,// 08
;      67 0x00, 0x41, 0x22, 0x1C, 0x00,// 09
;      68 0x14, 0x08, 0x3E, 0x08, 0x14,// 0A
;      69 0x08, 0x08, 0x3E, 0x08, 0x08,// 0B
;      70 0x00, 0x50, 0x30, 0x00, 0x00,// 0C
;      71 0x08, 0x08, 0x08, 0x08, 0x08,// 0D
;      72 0x00, 0x60, 0x60, 0x00, 0x00,// 0E
;      73 0x20, 0x10, 0x08, 0x04, 0x02,// 0F
;      74 0x00, 0x00, 0x00, 0x00, 0x00,// 10
;      75 0x00, 0x00, 0x5F, 0x00, 0x00,// 11
;      76 0x00, 0x07, 0x00, 0x07, 0x00,// 12
;      77 0x14, 0x7F, 0x14, 0x7F, 0x14,// 13
;      78 0x24, 0x2A, 0x7F, 0x2A, 0x12,// 14
;      79 0x23, 0x13, 0x08, 0x64, 0x62,// 15
;      80 0x36, 0x49, 0x55, 0x22, 0x50,// 16
;      81 0x00, 0x05, 0x03, 0x00, 0x00,// 17
;      82 0x00, 0x1C, 0x22, 0x41, 0x00,// 18
;      83 0x00, 0x41, 0x22, 0x1C, 0x00,// 19
;      84 0x14, 0x08, 0x3E, 0x08, 0x14,// 1A
;      85 0x08, 0x08, 0x3E, 0x08, 0x08,// 1B
;      86 0x00, 0x50, 0x30, 0x00, 0x00,// 1C
;      87 0x08, 0x08, 0x08, 0x08, 0x08,// 1D
;      88 0x00, 0x60, 0x60, 0x00, 0x00,// 1E
;      89 0x20, 0x10, 0x08, 0x04, 0x02,// 1F
;      90 0x00, 0x00, 0x00, 0x00, 0x00,// 20 space
;      91 0x00, 0x00, 0x5F, 0x00, 0x00,// 21 !
;      92 0x00, 0x07, 0x00, 0x07, 0x00,// 22 "
;      93 0x14, 0x7F, 0x14, 0x7F, 0x14,// 23 #
;      94 0x24, 0x2A, 0x7F, 0x2A, 0x12,// 24 $
;      95 0x23, 0x13, 0x08, 0x64, 0x62,// 25 %
;      96 0x36, 0x49, 0x55, 0x22, 0x50,// 26 &
;      97 0x00, 0x05, 0x03, 0x00, 0x00,// 27 '
;      98 0x00, 0x1C, 0x22, 0x41, 0x00,// 28 (
;      99 0x00, 0x41, 0x22, 0x1C, 0x00,// 29 )
;     100 0x14, 0x08, 0x3E, 0x08, 0x14,// 2a *
;     101 0x08, 0x08, 0x3E, 0x08, 0x08,// 2b +
;     102 0x00, 0x50, 0x30, 0x00, 0x00,// 2c ,
;     103 0x08, 0x08, 0x08, 0x08, 0x08,// 2d -
;     104 0x00, 0x60, 0x60, 0x00, 0x00,// 2e .
;     105 0x20, 0x10, 0x08, 0x04, 0x02,// 2f /
;     106 0x3E, 0x51, 0x49, 0x45, 0x3E,// 30 0
;     107 0x00, 0x42, 0x7F, 0x40, 0x00,// 31 1
;     108 0x42, 0x61, 0x51, 0x49, 0x46,// 32 2
;     109 0x21, 0x41, 0x45, 0x4B, 0x31,// 33 3
;     110 0x18, 0x14, 0x12, 0x7F, 0x10,// 34 4
;     111 0x27, 0x45, 0x45, 0x45, 0x39,// 35 5
;     112 0x3C, 0x4A, 0x49, 0x49, 0x30,// 36 6
;     113 0x01, 0x71, 0x09, 0x05, 0x03,// 37 7
;     114 0x36, 0x49, 0x49, 0x49, 0x36,// 38 8
;     115 0x06, 0x49, 0x49, 0x29, 0x1E,// 39 9
;     116 0x00, 0x36, 0x36, 0x00, 0x00,// 3a :
;     117 0x00, 0x56, 0x36, 0x00, 0x00,// 3b ;
;     118 0x08, 0x14, 0x22, 0x41, 0x00,// 3c <
;     119 0x14, 0x14, 0x14, 0x14, 0x14,// 3d =
;     120 0x00, 0x41, 0x22, 0x14, 0x08,// 3e >
;     121 0x02, 0x01, 0x51, 0x09, 0x06,// 3f ?
;     122 0x32, 0x49, 0x79, 0x41, 0x3E,// 40 @
;     123 0x7E, 0x11, 0x11, 0x11, 0x7E,// 41 A
;     124 0x7F, 0x49, 0x49, 0x49, 0x36,// 42 B
;     125 0x3E, 0x41, 0x41, 0x41, 0x22,// 43 C
;     126 0x7F, 0x41, 0x41, 0x22, 0x1C,// 44 D
;     127 0x7F, 0x49, 0x49, 0x49, 0x41,// 45 E
;     128 0x7F, 0x09, 0x09, 0x09, 0x01,// 46 F
;     129 0x3E, 0x41, 0x49, 0x49, 0x7A,// 47 G
;     130 0x7F, 0x08, 0x08, 0x08, 0x7F,// 48 H
;     131 0x00, 0x41, 0x7F, 0x41, 0x00,// 49 I
;     132 0x20, 0x40, 0x41, 0x3F, 0x01,// 4a J
;     133 0x7F, 0x08, 0x14, 0x22, 0x41,// 4b K
;     134 0x7F, 0x40, 0x40, 0x40, 0x40,// 4c L
;     135 0x7F, 0x02, 0x0C, 0x02, 0x7F,// 4d M
;     136 0x7F, 0x04, 0x08, 0x10, 0x7F,// 4e N
;     137 0x3E, 0x41, 0x41, 0x41, 0x3E,// 4f O
;     138 0x7F, 0x09, 0x09, 0x09, 0x06,// 50 P
;     139 0x3E, 0x41, 0x51, 0x21, 0x5E,// 51 Q
;     140 0x7F, 0x09, 0x19, 0x29, 0x46,// 52 R
;     141 0x46, 0x49, 0x49, 0x49, 0x31,// 53 S
;     142 0x01, 0x01, 0x7F, 0x01, 0x01,// 54 T
;     143 0x3F, 0x40, 0x40, 0x40, 0x3F,// 55 U
;     144 0x1F, 0x20, 0x40, 0x20, 0x1F,// 56 V
;     145 0x3F, 0x40, 0x38, 0x40, 0x3F,// 57 W
;     146 0x63, 0x14, 0x08, 0x14, 0x63,// 58 X
;     147 0x07, 0x08, 0x70, 0x08, 0x07,// 59 Y
;     148 0x61, 0x51, 0x49, 0x45, 0x43,// 5a Z
;     149 0x00, 0x7F, 0x41, 0x41, 0x00,// 5b [
;     150 0x02, 0x04, 0x08, 0x10, 0x20,// 5c Yen Currency Sign
;     151 0x00, 0x41, 0x41, 0x7F, 0x00,// 5d ]
;     152 0x04, 0x02, 0x01, 0x02, 0x04,// 5e ^
;     153 0x40, 0x40, 0x40, 0x40, 0x40,// 5f _
;     154 0x00, 0x01, 0x02, 0x04, 0x00,// 60 `
;     155 0x20, 0x54, 0x54, 0x54, 0x78,// 61 a
;     156 0x7F, 0x48, 0x44, 0x44, 0x38,// 62 b
;     157 0x38, 0x44, 0x44, 0x44, 0x20,// 63 c
;     158 0x38, 0x44, 0x44, 0x48, 0x7F,// 64 d
;     159 0x38, 0x54, 0x54, 0x54, 0x18,// 65 e
;     160 0x08, 0x7E, 0x09, 0x01, 0x02,// 66 f
;     161 0x0C, 0x52, 0x52, 0x52, 0x3E,// 67 g
;     162 0x7F, 0x08, 0x04, 0x04, 0x78,// 68 h
;     163 0x00, 0x44, 0x7D, 0x40, 0x00,// 69 i
;     164 0x20, 0x40, 0x44, 0x3D, 0x00,// 6a j
;     165 0x7F, 0x10, 0x28, 0x44, 0x00,// 6b k
;     166 0x00, 0x41, 0x7F, 0x40, 0x00,// 6c l
;     167 0x7C, 0x04, 0x18, 0x04, 0x78,// 6d m
;     168 0x7C, 0x08, 0x04, 0x04, 0x78,// 6e n
;     169 0x38, 0x44, 0x44, 0x44, 0x38,// 6f o
;     170 0x7C, 0x14, 0x14, 0x14, 0x08,// 70 p
;     171 0x08, 0x14, 0x14, 0x18, 0x7C,// 71 q
;     172 0x7C, 0x08, 0x04, 0x04, 0x08,// 72 r
;     173 0x48, 0x54, 0x54, 0x54, 0x20,// 73 s
;     174 0x04, 0x3F, 0x44, 0x40, 0x20,// 74 t
;     175 0x3C, 0x40, 0x40, 0x20, 0x7C,// 75 u
;     176 0x1C, 0x20, 0x40, 0x20, 0x1C,// 76 v
;     177 0x3C, 0x40, 0x30, 0x40, 0x3C,// 77 w
;     178 0x44, 0x28, 0x10, 0x28, 0x44,// 78 x
;     179 0x0C, 0x50, 0x50, 0x50, 0x3C,// 79 y
;     180 0x44, 0x64, 0x54, 0x4C, 0x44,// 7a z
;     181 0x00, 0x08, 0x36, 0x41, 0x00,// 7b <
;     182 0x00, 0x00, 0x7F, 0x00, 0x00,// 7c |
;     183 0x00, 0x41, 0x36, 0x08, 0x00,// 7d >
;     184 0x10, 0x08, 0x08, 0x10, 0x08,// 7e Right Arrow ->
;     185 0x78, 0x46, 0x41, 0x46, 0x78,// 7f Left Arrow <-
;     186 0x00, 0x00, 0x00, 0x00, 0x00,// 80
;     187 0x00, 0x00, 0x5F, 0x00, 0x00,// 81
;     188 0x00, 0x07, 0x00, 0x07, 0x00,// 82
;     189 0x14, 0x7F, 0x14, 0x7F, 0x14,// 83
;     190 0x24, 0x2A, 0x7F, 0x2A, 0x12,// 84
;     191 0x23, 0x13, 0x08, 0x64, 0x62,// 85
;     192 0x36, 0x49, 0x55, 0x22, 0x50,// 86
;     193 0x00, 0x05, 0x03, 0x00, 0x00,// 87
;     194 0x00, 0x1C, 0x22, 0x41, 0x00,// 88
;     195 0x00, 0x41, 0x22, 0x1C, 0x00,// 89
;     196 0x14, 0x08, 0x3E, 0x08, 0x14,// 8A
;     197 0x08, 0x08, 0x3E, 0x08, 0x08,// 8B
;     198 0x00, 0x50, 0x30, 0x00, 0x00,// 8C
;     199 0x08, 0x08, 0x08, 0x08, 0x08,// 8D
;     200 0x00, 0x60, 0x60, 0x00, 0x00,// 8E
;     201 0x20, 0x10, 0x08, 0x04, 0x02,// 8F
;     202 0x00, 0x00, 0x00, 0x00, 0x00,// 90
;     203 0x00, 0x00, 0x5F, 0x00, 0x00,// 91
;     204 0x00, 0x07, 0x00, 0x07, 0x00,// 92
;     205 0x14, 0x7F, 0x14, 0x7F, 0x14,// 93
;     206 0x24, 0x2A, 0x7F, 0x2A, 0x12,// 94
;     207 0x23, 0x13, 0x08, 0x64, 0x62,// 95
;     208 0x36, 0x49, 0x55, 0x22, 0x50,// 96
;     209 0x00, 0x05, 0x03, 0x00, 0x00,// 97
;     210 0x00, 0x1C, 0x22, 0x41, 0x00,// 98
;     211 0x00, 0x41, 0x22, 0x1C, 0x00,// 99
;     212 0x14, 0x08, 0x3E, 0x08, 0x14,// 9A
;     213 0x08, 0x08, 0x3E, 0x08, 0x08,// 9B
;     214 0x00, 0x50, 0x30, 0x00, 0x00,// 9C
;     215 0x08, 0x08, 0x08, 0x08, 0x08,// 9D
;     216 0x00, 0x60, 0x60, 0x00, 0x00,// 9E
;     217 0x20, 0x10, 0x08, 0x04, 0x02,// 9F
;     218 0x00, 0x00, 0x00, 0x00, 0x00,// A0
;     219 0x00, 0x00, 0x5F, 0x00, 0x00,// A1
;     220 0x00, 0x07, 0x00, 0x07, 0x00,// A2
;     221 0x14, 0x7F, 0x14, 0x7F, 0x14,// A3
;     222 0x24, 0x2A, 0x7F, 0x2A, 0x12,// A4
;     223 0x23, 0x13, 0x08, 0x64, 0x62,// A5
;     224 0x36, 0x49, 0x55, 0x22, 0x50,// A6
;     225 0x00, 0x05, 0x03, 0x00, 0x00,// A7
;     226 0x00, 0x1C, 0x22, 0x41, 0x00,// A8
;     227 0x00, 0x41, 0x22, 0x1C, 0x00,// A9
;     228 0x14, 0x08, 0x3E, 0x08, 0x14,// AA
;     229 0x08, 0x08, 0x3E, 0x08, 0x08,// AB
;     230 0x00, 0x50, 0x30, 0x00, 0x00,// AC
;     231 0x08, 0x08, 0x08, 0x08, 0x08,// AD
;     232 0x00, 0x60, 0x60, 0x00, 0x00,// AE
;     233 0x20, 0x10, 0x08, 0x04, 0x02,// AF
;     234 0x3E, 0x51, 0x49, 0x45, 0x3E,// B0
;     235 0x00, 0x42, 0x7F, 0x40, 0x00,// B1
;     236 0x42, 0x61, 0x51, 0x49, 0x46,// B2
;     237 0x21, 0x41, 0x45, 0x4B, 0x31,// B3
;     238 0x18, 0x14, 0x12, 0x7F, 0x10,// B4
;     239 0x27, 0x45, 0x45, 0x45, 0x39,// B5
;     240 0x3C, 0x4A, 0x49, 0x49, 0x30,// B6
;     241 0x01, 0x71, 0x09, 0x05, 0x03,// B7
;     242 0x36, 0x49, 0x49, 0x49, 0x36,// B8
;     243 0x06, 0x49, 0x49, 0x29, 0x1E,// B9
;     244 0x00, 0x36, 0x36, 0x00, 0x00,// BA
;     245 0x00, 0x56, 0x36, 0x00, 0x00,// BB
;     246 0x08, 0x14, 0x22, 0x41, 0x00,// BC
;     247 0x14, 0x14, 0x14, 0x14, 0x14,// BD
;     248 0x00, 0x41, 0x22, 0x14, 0x08,// BE
;     249 0x02, 0x01, 0x51, 0x09, 0x06,// BF
;     250 0x7E, 0x11, 0x11, 0x11, 0x7E,// C0 ?
;     251 0x7F, 0x49, 0x49, 0x49, 0x31,// C1 ?
;     252 0x7F, 0x49, 0x49, 0x49, 0x36,// C2 ?
;     253 0x7F, 0x01, 0x01, 0x01, 0x03,// C3 ?
;     254 0x70, 0x29, 0x27, 0x21, 0x7F,// C4 ?
;     255 0x7F, 0x49, 0x49, 0x49, 0x41,// C5 ?
;     256 0x77, 0x08, 0x7F, 0x08, 0x77,// C6 ?
;     257 0x41, 0x41, 0x41, 0x49, 0x76,// C7 ?
;     258 0x7F, 0x10, 0x08, 0x04, 0x7F,// C8 ?
;     259 0x7F, 0x10, 0x09, 0x04, 0x7F,// C9 ?
;     260 0x7F, 0x08, 0x14, 0x22, 0x41,// CA ?
;     261 0x20, 0x41, 0x3F, 0x01, 0x7F,// CB ?
;     262 0x7F, 0x02, 0x0C, 0x02, 0x7F,// CC ?
;     263 0x7F, 0x08, 0x08, 0x08, 0x7F,// CD ?
;     264 0x3E, 0x41, 0x41, 0x41, 0x3E,// CE ?
;     265 0x7F, 0x01, 0x01, 0x01, 0x7F,// CF ?
;     266 0x7F, 0x09, 0x09, 0x09, 0x06,// D0 ?
;     267 0x3E, 0x41, 0x41, 0x41, 0x22,// D1 ?
;     268 0x01, 0x01, 0x7F, 0x01, 0x01,// D2 ?
;     269 0x47, 0x28, 0x10, 0x08, 0x07,// D3 ?
;     270 0x1E, 0x21, 0x7F, 0x21, 0x1E,// D4 ?
;     271 0x63, 0x14, 0x08, 0x14, 0x63,// D5 ?
;     272 0x3F, 0x20, 0x20, 0x20, 0x5F,// D6 ?
;     273 0x07, 0x08, 0x08, 0x08, 0x7F,// D7 ?
;     274 0x7F, 0x40, 0x7F, 0x40, 0x7F,// D8 ?
;     275 0x3F, 0x20, 0x3F, 0x20, 0x5F,// D9 ?
;     276 0x01, 0x7F, 0x48, 0x48, 0x30,// DA ?
;     277 0x7F, 0x48, 0x30, 0x00, 0x7F,// DB ?
;     278 0x00, 0x7F, 0x48, 0x48, 0x30,// DC ?
;     279 0x41, 0x41, 0x41, 0x49, 0x3E,// DD ?
;     280 0x7F, 0x08, 0x3E, 0x41, 0x3E,// DE ?
;     281 0x46, 0x29, 0x19, 0x09, 0x7F,// DF ?
;     282 0x20, 0x54, 0x54, 0x54, 0x78,// E0 ?
;     283 0x3C, 0x4A, 0x4A, 0x49, 0x31,// E1 ?
;     284 0x7C, 0x54, 0x54, 0x28, 0x00,// E2 ?
;     285 0x7C, 0x04, 0x04, 0x04, 0x0C,// E3 ?
;     286 0x72, 0x2A, 0x26, 0x22, 0x7E,// E4 ?
;     287 0x38, 0x54, 0x54, 0x54, 0x18,// E5 ?
;     288 0x6C, 0x10, 0x7C, 0x10, 0x6C,// E6 ?
;     289 0x44, 0x44, 0x54, 0x54, 0x38,// E7 ?
;     290 0x7C, 0x20, 0x10, 0x08, 0x7C,// E8 ?
;     291 0x7C, 0x21, 0x12, 0x09, 0x7C,// E9 ?
;     292 0x7C, 0x10, 0x28, 0x44, 0x00,// EA ?
;     293 0x20, 0x44, 0x3C, 0x04, 0x7C,// EB ?
;     294 0x7C, 0x08, 0x10, 0x08, 0x7C,// EC ?
;     295 0x7C, 0x10, 0x10, 0x10, 0x7C,// ED ?
;     296 0x38, 0x44, 0x44, 0x44, 0x38,// EE ?
;     297 0x7C, 0x04, 0x04, 0x04, 0x7C,// EF ?
;     298 0x7C, 0x14, 0x14, 0x14, 0x08,// F0 ?
;     299 0x38, 0x44, 0x44, 0x44, 0x20,// F1 ?
;     300 0x04, 0x04, 0x7C, 0x04, 0x04,// F2 ?
;     301 0x44, 0x28, 0x10, 0x08, 0x04,// F3 ?
;     302 0x08, 0x14, 0x7E, 0x14, 0x08,// F4 ?
;     303 0x44, 0x28, 0x10, 0x28, 0x44,// F5 ?
;     304 0x3C, 0x40, 0x40, 0x7C, 0x40,// F6 ?
;     305 0x0C, 0x10, 0x10, 0x10, 0x7C,// F7 ?
;     306 0x7C, 0x40, 0x7C, 0x40, 0x7C,// F8 ?
;     307 0x3C, 0x20, 0x3C, 0x20, 0x7C,// F9 ?
;     308 0x04, 0x7C, 0x50, 0x50, 0x20,// FA ?
;     309 0x7C, 0x50, 0x20, 0x00, 0x7C,// FB ?
;     310 0x00, 0x7C, 0x50, 0x50, 0x20,// FC ?
;     311 0x28, 0x44, 0x44, 0x54, 0x38,// FD ?
;     312 0x7C, 0x10, 0x38, 0x44, 0x38,// FE ?
;     313 0x48, 0x54, 0x34, 0x14, 0x7C }; // FF
;     314 
;     315 void LcdSend (unsigned char data, unsigned char cmd)    //Sends data to display controller
;     316 {
_LcdSend:
;     317   LCD_PORT.LCD_CE_PIN = 0;                              //Enable display controller (active low)
;	data -> Y+1
;	cmd -> Y+0
	CBI  0x18,1
;     318 
;     319   if (cmd) LCD_PORT.LCD_DC_PIN = 1;	                    //   
	LD   R30,Y
	CPI  R30,0
	BREQ _0x5
	SBI  0x18,2
;     320 
;     321     else LCD_PORT.LCD_DC_PIN = 0;
	RJMP _0x8
_0x5:
	CBI  0x18,2
;     322     SPDR = data;                                          //Send data to display controller
_0x8:
	LDD  R30,Y+1
	OUT  0xF,R30
;     323 
;     324   while ( (SPSR & 0x80) != 0x80 );                      //Wait until Tx register empty
_0xB:
	IN   R30,0xE
	ANDI R30,LOW(0x80)
	CPI  R30,LOW(0x80)
	BRNE _0xB
;     325   LCD_PORT.LCD_CE_PIN = 1;                              //Disable display controller
	SBI  0x18,1
;     326 }
	RJMP _0x118
;     327 
;     328 void LcdUpdate (void)                                   //Copies the LCD cache into the device RAM
;     329 {
_LcdUpdate:
;     330   int i;
;     331   char j;
;     332 
;     333   LcdSend(0x80, LCD_CMD);		//      0,0
	RCALL __SAVELOCR4
;	i -> R16,R17
;	j -> R19
	LDI  R30,LOW(128)
	RCALL SUBOPT_0x0
;     334   LcdSend(0x40, LCD_CMD);
	LDI  R30,LOW(64)
	RCALL SUBOPT_0x0
;     335 
;     336   for (i = 0; i < LCD_CACHE_SIZE; i++)		// 
	__GETWRN 16,17,0
_0x11:
	__CPWRN 16,17,504
	BRGE _0x12
;     337   {
;     338     LcdSend(LcdCache[i], LCD_DATA);
	RCALL SUBOPT_0x1
	LD   R30,X
	RCALL SUBOPT_0x2
	RCALL _LcdSend
;     339   }
	__ADDWRN 16,17,1
	RJMP _0x11
_0x12:
;     340 }
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;     341 
;     342 void LcdClear (void)    //Clears the display
;     343   {
_LcdClear:
;     344     int i;
;     345 
;     346 	  for (i = 0; i < LCD_CACHE_SIZE; i++) LcdCache[i] = 0;	//   0
	RCALL __SAVELOCR2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x14:
	__CPWRN 16,17,504
	BRGE _0x15
	RCALL SUBOPT_0x1
	LDI  R30,LOW(0)
	ST   X,R30
;     347 	  LcdUpdate ();
	__ADDWRN 16,17,1
	RJMP _0x14
_0x15:
	RCALL _LcdUpdate
;     348    }
	RCALL __LOADLOCR2P
	RET
;     349 
;     350 
;     351 void LcdInit ( void )	// SPI  
;     352 {
_LcdInit:
;     353   LCD_PORT.LCD_RST_PIN = 1;       //  /
	SBI  0x18,0
;     354   LCD_DDR.LCD_RST_PIN = LCD_DDR.LCD_DC_PIN = LCD_DDR.LCD_CE_PIN = LCD_DDR.SPI_MOSI_PIN = LCD_DDR.SPI_CLK_PIN = 1;
	LDI  R30,LOW(1)
	CPI  R30,0
	BRNE _0x18
	CBI  0x17,5
	RJMP _0x19
_0x18:
	SBI  0x17,5
_0x19:
	CPI  R30,0
	BRNE _0x1A
	CBI  0x17,3
	RJMP _0x1B
_0x1A:
	SBI  0x17,3
_0x1B:
	CPI  R30,0
	BRNE _0x1C
	CBI  0x17,1
	RJMP _0x1D
_0x1C:
	SBI  0x17,1
_0x1D:
	CPI  R30,0
	BRNE _0x1E
	CBI  0x17,2
	RJMP _0x1F
_0x1E:
	SBI  0x17,2
_0x1F:
	CPI  R30,0
	BRNE _0x20
	CBI  0x17,0
	RJMP _0x21
_0x20:
	SBI  0x17,0
_0x21:
;     355   delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x3
;     356   SPCR = 0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
;     357   LCD_PORT.LCD_RST_PIN = 0;       // 
	CBI  0x18,0
;     358   delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x3
;     359   LCD_PORT.LCD_RST_PIN = 1;
	SBI  0x18,0
;     360 
;     361   LCD_PORT.LCD_CE_PIN = 1;        //Disable LCD controller
	SBI  0x18,1
;     362 
;     363   LcdSend( 0x21, LCD_CMD ); 			//LCD Extended Commands
	LDI  R30,LOW(33)
	RCALL SUBOPT_0x0
;     364   LcdSend( 0x06, LCD_CMD ); 			//Set Temp coefficent
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x0
;     365   LcdSend( 0x13, LCD_CMD ); 			//LCD bias mode 1:48
	LDI  R30,LOW(19)
	RCALL SUBOPT_0x0
;     366   LcdSend( 0xC8, LCD_CMD ); 			//Set LCD Vop (Contrast)
	LDI  R30,LOW(200)
	RCALL SUBOPT_0x0
;     367   LcdSend (0x20, 0);              //Horizontal addressing mode.
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x0
;     368 	LcdSend (0x0C, 0);              //normal mode.
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x0
;     369 
;     370   LcdClear();
	RCALL _LcdClear
;     371 };
	RET
;     372 
;     373 void LcdPixel (unsigned char x, unsigned char y, unsigned char mode)     //Displays a pixel at given absolute (x, y) location, mode -> Off, On or Xor
;     374 {
;     375   int index;
;     376   unsigned char offset, data;
;     377 
;     378   if ( x > LCD_X_RES ) return;	//     - 
;	x -> Y+6
;	y -> Y+5
;	mode -> Y+4
;	index -> R16,R17
;	offset -> R19
;	data -> R18
;     379   if ( y > LCD_Y_RES ) return;
;     380 
;     381   index = (((int)(y)/8)*84)+x;    //      
;     382   offset  = y-((y/8)*8);          //     
;     383 
;     384   data = LcdCache[index];         //    
;     385 
;     386   LcdCache[index] = data;		//  
;     387 }
;     388 
;     389 void LcdGotoXYFont (unsigned char x, unsigned char y)   //Sets cursor location to xy location. Range: 1,1 .. 14,6
;     390 {
_LcdGotoXYFont:
;     391   if (x <= 14 && y<= 6) LcdCacheIdx = ( (int)(y) - 1 ) * 84 + ( (int)(x) - 1 ) * 6;
;	x -> Y+1
;	y -> Y+0
	LDD  R26,Y+1
	CPI  R26,LOW(0xF)
	BRSH _0x2B
	LD   R26,Y
	CPI  R26,LOW(0x7)
	BRLO _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
	LD   R30,Y
	RCALL SUBOPT_0x4
	LDI  R26,LOW(84)
	LDI  R27,HIGH(84)
	RCALL __MULW12
	MOVW R22,R30
	LDD  R30,Y+1
	RCALL SUBOPT_0x4
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	RCALL __MULW12
	ADD  R30,R22
	ADC  R31,R23
	MOVW R4,R30
;     392 }
_0x2A:
_0x118:
	ADIW R28,2
	RET
;     393 
;     394 void clean_lcd_buf (void)	//  
;     395 {
_clean_lcd_buf:
;     396   char i;
;     397 
;     398   for (i=0; i<14; i++) lcd_buf[i] = 0;
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x2E:
	CPI  R17,14
	BRSH _0x2F
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
;     399 }
	SUBI R17,-1
	RJMP _0x2E
_0x2F:
	LD   R17,Y+
	RET
;     400 
;     401 void LcdChr (int ch)	//Displays a character at current cursor location and increment cursor location
;     402 {
_LcdChr:
;     403   unsigned char i;
;     404 
;     405   for ( i = 0; i < 5; i++ ) LcdCache[LcdCacheIdx++] = table[(ch*5+i)];	// -       - 5 
	ST   -Y,R17
;	ch -> Y+1
;	i -> R17
	LDI  R17,LOW(0)
_0x31:
	CPI  R17,5
	BRSH _0x32
	RCALL SUBOPT_0x8
	MOVW R22,R30
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	LPM  R30,Z
	MOVW R26,R22
	ST   X,R30
;     406   LcdCache[LcdCacheIdx++] = 0x00;	//   
	SUBI R17,-1
	RJMP _0x31
_0x32:
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
;     407 }
	LDD  R17,Y+0
	RJMP _0x116
;     408 
;     409 void LcdString (unsigned char x, unsigned char y)	//Displays a string at current cursor location
;     410 {
_LcdString:
;     411   unsigned char i;
;     412 
;     413   if (x > 14 && y > 6) return;
	ST   -Y,R17
;	x -> Y+2
;	y -> Y+1
;	i -> R17
	LDD  R26,Y+2
	CPI  R26,LOW(0xF)
	BRLO _0x34
	LDD  R26,Y+1
	CPI  R26,LOW(0x7)
	BRSH _0x35
_0x34:
	RJMP _0x33
_0x35:
	LDD  R17,Y+0
	RJMP _0x116
;     414   LcdGotoXYFont (x, y);
_0x33:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xB
	RCALL _LcdGotoXYFont
;     415   for ( i = 0; i < 15-x; i++ ) if (lcd_buf[i]) LcdChr (lcd_buf[i]);
	LDI  R17,LOW(0)
_0x37:
	RCALL SUBOPT_0xC
	BRSH _0x38
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xD
	CPI  R30,0
	BREQ _0x39
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RCALL _LcdChr
;     416   clean_lcd_buf();
_0x39:
	SUBI R17,-1
	RJMP _0x37
_0x38:
	RCALL _clean_lcd_buf
;     417 }
	LDD  R17,Y+0
	RJMP _0x116
;     418 
;     419 void LcdChrBold (int ch)	//Displays a bold character at current cursor location and increment cursor location
;     420 {
_LcdChrBold:
;     421   unsigned char i;
;     422   unsigned char a = 0, b = 0, c = 0;
;     423 
;     424   for ( i = 0; i < 5; i++ )
	RCALL SUBOPT_0xF
;	ch -> Y+4
;	i -> R17
;	a -> R16
;	b -> R19
;	c -> R18
_0x3B:
	CPI  R17,5
	BRSH _0x3C
;     425 {
;     426   c = table[(ch*5+i)];		        //   
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x10
;     427 
;     428   b =  (c & 0x01) * 3;            //""    
;     429   b |= (c & 0x02) * 6;
;     430   b |= (c & 0x04) * 12;
;     431   b |= (c & 0x08) * 24;
;     432 
;     433   c >>= 4;
;     434   a =  (c & 0x01) * 3;
;     435   a |= (c & 0x02) * 6;
;     436   a |= (c & 0x04) * 12;
;     437   a |= (c & 0x08) * 24;
	RCALL SUBOPT_0x11
;     438 
;     439   LcdCache[LcdCacheIdx] = b;	    //    
;     440   LcdCache[LcdCacheIdx+1] = b;    //    
	__ADDW1MN _LcdCache,1
	ST   Z,R19
;     441   LcdCache[LcdCacheIdx+84] = a;
	MOVW R30,R4
	RCALL SUBOPT_0x12
;     442   LcdCache[LcdCacheIdx+85] = a;
	__ADDW1MN _LcdCache,85
	ST   Z,R16
;     443   LcdCacheIdx = LcdCacheIdx+2;
	MOVW R30,R4
	ADIW R30,2
	MOVW R4,R30
;     444   }
	SUBI R17,-1
	RJMP _0x3B
_0x3C:
;     445 
;     446   LcdCache[LcdCacheIdx++] = 0x00;	//   
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
;     447   LcdCache[LcdCacheIdx++] = 0x00;
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
;     448  	}
	RJMP _0x117
;     449 
;     450 void LcdStringBold (unsigned char x, unsigned char y)	//Displays a string at current cursor location
;     451 {
_LcdStringBold:
;     452 unsigned char i;
;     453 
;     454 if (x > 13 && y > 5) return;
	ST   -Y,R17
;	x -> Y+2
;	y -> Y+1
;	i -> R17
	LDD  R26,Y+2
	CPI  R26,LOW(0xE)
	BRLO _0x3E
	LDD  R26,Y+1
	CPI  R26,LOW(0x6)
	BRSH _0x3F
_0x3E:
	RJMP _0x3D
_0x3F:
	LDD  R17,Y+0
	RJMP _0x116
;     455 LcdGotoXYFont (x, y);
_0x3D:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xB
	RCALL _LcdGotoXYFont
;     456 for ( i = 0; i < 14-x; i++ ) if (lcd_buf[i]) LcdChrBold (lcd_buf[i]);
	LDI  R17,LOW(0)
_0x41:
	LDD  R26,Y+2
	LDI  R30,LOW(14)
	SUB  R30,R26
	CP   R17,R30
	BRSH _0x42
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xD
	CPI  R30,0
	BREQ _0x43
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RCALL _LcdChrBold
;     457 clean_lcd_buf();
_0x43:
	SUBI R17,-1
	RJMP _0x41
_0x42:
	RCALL _clean_lcd_buf
;     458 }
	LDD  R17,Y+0
	RJMP _0x116
;     459 
;     460 void LcdChrBig (int ch)	//Displays a character at current cursor location and increment cursor location
;     461 {
_LcdChrBig:
;     462   unsigned char i;
;     463   unsigned char a = 0, b = 0, c = 0;
;     464 
;     465   for ( i = 0; i < 5; i++ )
	RCALL SUBOPT_0xF
;	ch -> Y+4
;	i -> R17
;	a -> R16
;	b -> R19
;	c -> R18
_0x45:
	CPI  R17,5
	BRSH _0x46
;     466 {
;     467   c = table[(ch*5+i)];		//   
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x10
;     468 
;     469   b =  (c & 0x01) * 3;            //""    
;     470   b |= (c & 0x02) * 6;
;     471   b |= (c & 0x04) * 12;
;     472   b |= (c & 0x08) * 24;
;     473 
;     474   c >>= 4;
;     475   a =  (c & 0x01) * 3;
;     476   a |= (c & 0x02) * 6;
;     477   a |= (c & 0x04) * 12;
;     478   a |= (c & 0x08) * 24;
	RCALL SUBOPT_0x11
;     479   LcdCache[LcdCacheIdx] = b;
;     480   LcdCache[LcdCacheIdx+84] = a;
	RCALL SUBOPT_0x12
;     481   LcdCacheIdx = LcdCacheIdx+1;
	ADIW R30,1
	MOVW R4,R30
;     482 }
	SUBI R17,-1
	RJMP _0x45
_0x46:
;     483 
;     484   LcdCache[LcdCacheIdx++] = 0x00;
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
;     485 }
_0x117:
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
;     486 
;     487 void LcdStringBig (unsigned char x, unsigned char y)	//Displays a string at current cursor location
;     488 {
_LcdStringBig:
;     489   unsigned char i;
;     490 
;     491   if (x > 14 && y > 5) return;
	ST   -Y,R17
;	x -> Y+2
;	y -> Y+1
;	i -> R17
	LDD  R26,Y+2
	CPI  R26,LOW(0xF)
	BRLO _0x48
	LDD  R26,Y+1
	CPI  R26,LOW(0x6)
	BRSH _0x49
_0x48:
	RJMP _0x47
_0x49:
	LDD  R17,Y+0
	RJMP _0x116
;     492   LcdGotoXYFont (x, y);
_0x47:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xB
	RCALL _LcdGotoXYFont
;     493   for ( i = 0; i < 15-x; i++ ) if (lcd_buf[i]) LcdChrBig (lcd_buf[i]);
	LDI  R17,LOW(0)
_0x4B:
	RCALL SUBOPT_0xC
	BRSH _0x4C
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xD
	CPI  R30,0
	BREQ _0x4D
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RCALL _LcdChrBig
;     494   clean_lcd_buf();
_0x4D:
	SUBI R17,-1
	RJMP _0x4B
_0x4C:
	RCALL _clean_lcd_buf
;     495 }
	LDD  R17,Y+0
_0x116:
	ADIW R28,3
	RET
;     496 
;     497 void main(void)
;     498 {
_main:
;     499   char i;
;     500 
;     501   LcdInit();
;	i -> R17
	RCALL _LcdInit
;     502 
;     503   while (1)
_0x4E:
;     504   {
;     505 
;     506   LcdClear();
	RCALL SUBOPT_0x13
;     507   LcdUpdate();
;     508   delay_ms(2000);
;     509   LcdClear();
	RCALL SUBOPT_0x13
;     510   LcdUpdate();
;     511   delay_ms(2000);
;     512 
;     513   LcdClear();
	RCALL _LcdClear
;     514 
;     515 	for (i=0; i<10; i++)
	LDI  R17,LOW(0)
_0x52:
	CPI  R17,10
	BRSH _0x53
;     516 		{
;     517 		  sprintf (lcd_buf, "=%u", i);
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
;     518 		  LcdString(1,1);
	RCALL _LcdString
;     519 		  sprintf (lcd_buf, "=%u", i);  // 1
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x16
;     520 		  LcdStringBold(1,2);
;     521 		  sprintf (lcd_buf, "Bufe=%u/", i); //1 
	RCALL SUBOPT_0x17
;     522 		  LcdStringBig(1,4);
;     523 		  sprintf (lcd_buf, "%u", i);
	RCALL SUBOPT_0x18
;     524 		  LcdStringBold(9,4);
;     525 	    sprintf (lcd_buf, "Bufer=%u ", i+2); //sprintf (lcd_buf, "=%u ", i+2);
	__POINTW1FN _0,26
	RCALL SUBOPT_0x19
;     526 	    LcdString(1,6);
;     527 		  LcdUpdate();
;     528 
;     529 		  delay_ms(300);
;     530 		}
	SUBI R17,-1
	RJMP _0x52
_0x53:
;     531 
;     532 	for (i=0; i<10; i++)
	LDI  R17,LOW(0)
_0x55:
	CPI  R17,10
	BRSH _0x56
;     533 		{
;     534 		  sprintf (lcd_buf, "=%u", i);
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
;     535 		  LcdString(1,1);
	RCALL _LcdString
;     536 		  sprintf (lcd_buf, "=%u", i);  // 2
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x16
;     537 		  LcdStringBold(1,2);
;     538 		  sprintf (lcd_buf, "Bufe=%u/", i); //1 
	RCALL SUBOPT_0x17
;     539 		  LcdStringBig(1,4);
;     540 		  sprintf (lcd_buf, "%u", i);
	RCALL SUBOPT_0x18
;     541 		  LcdStringBold(9,4);
;     542 	    sprintf (lcd_buf, "=%u ", i+2);
	__POINTW1FN _0,36
	RCALL SUBOPT_0x19
;     543 	    LcdString(1,6);
;     544 		  LcdUpdate();
;     545 
;     546 		  delay_ms(300);
;     547 		}
	SUBI R17,-1
	RJMP _0x55
_0x56:
;     548 	};
	RJMP _0x4E
;     549 }
_0x57:
	RJMP _0x57

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x65
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x67
	__CPWRN 16,17,2
	BRLO _0x68
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x67:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x68:
	RJMP _0x69
_0x65:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x69:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x6A:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x6C
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x70
	CPI  R18,37
	BRNE _0x71
	LDI  R17,LOW(1)
	RJMP _0x72
_0x71:
	RCALL SUBOPT_0x1A
_0x72:
	RJMP _0x6F
_0x70:
	CPI  R30,LOW(0x1)
	BRNE _0x73
	CPI  R18,37
	BRNE _0x74
	RCALL SUBOPT_0x1A
	RJMP _0x119
_0x74:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x75
	LDI  R16,LOW(1)
	RJMP _0x6F
_0x75:
	CPI  R18,43
	BRNE _0x76
	LDI  R20,LOW(43)
	RJMP _0x6F
_0x76:
	CPI  R18,32
	BRNE _0x77
	LDI  R20,LOW(32)
	RJMP _0x6F
_0x77:
	RJMP _0x78
_0x73:
	CPI  R30,LOW(0x2)
	BRNE _0x79
_0x78:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x7A
	ORI  R16,LOW(128)
	RJMP _0x6F
_0x7A:
	RJMP _0x7B
_0x79:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x6F
_0x7B:
	CPI  R18,48
	BRLO _0x7E
	CPI  R18,58
	BRLO _0x7F
_0x7E:
	RJMP _0x7D
_0x7F:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x6F
_0x7D:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x83
	RCALL SUBOPT_0x1B
	LD   R30,X
	RCALL SUBOPT_0x1C
	RJMP _0x84
_0x83:
	CPI  R30,LOW(0x73)
	BRNE _0x86
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x1D
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x87
_0x86:
	CPI  R30,LOW(0x70)
	BRNE _0x89
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x1D
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x87:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x8A
_0x89:
	CPI  R30,LOW(0x64)
	BREQ _0x8D
	CPI  R30,LOW(0x69)
	BRNE _0x8E
_0x8D:
	ORI  R16,LOW(4)
	RJMP _0x8F
_0x8E:
	CPI  R30,LOW(0x75)
	BRNE _0x90
_0x8F:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	RCALL SUBOPT_0x1E
	LDI  R17,LOW(5)
	RJMP _0x91
_0x90:
	CPI  R30,LOW(0x58)
	BRNE _0x93
	ORI  R16,LOW(8)
	RJMP _0x94
_0x93:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xC5
_0x94:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	RCALL SUBOPT_0x1E
	LDI  R17,LOW(4)
_0x91:
	SBRS R16,2
	RJMP _0x96
	RCALL SUBOPT_0x1B
	RCALL __GETW1P
	RCALL SUBOPT_0x1F
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x97
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x1F
	LDI  R20,LOW(45)
_0x97:
	CPI  R20,0
	BREQ _0x98
	SUBI R17,-LOW(1)
	RJMP _0x99
_0x98:
	ANDI R16,LOW(251)
_0x99:
	RJMP _0x9A
_0x96:
	RCALL SUBOPT_0x1B
	RCALL __GETW1P
	RCALL SUBOPT_0x1F
_0x9A:
_0x8A:
	SBRC R16,0
	RJMP _0x9B
_0x9C:
	CP   R17,R21
	BRSH _0x9E
	SBRS R16,7
	RJMP _0x9F
	SBRS R16,2
	RJMP _0xA0
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0xA1
_0xA0:
	LDI  R18,LOW(48)
_0xA1:
	RJMP _0xA2
_0x9F:
	LDI  R18,LOW(32)
_0xA2:
	RCALL SUBOPT_0x1A
	SUBI R21,LOW(1)
	RJMP _0x9C
_0x9E:
_0x9B:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0xA3
_0xA4:
	CPI  R19,0
	BREQ _0xA6
	SBRS R16,3
	RJMP _0xA7
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x1E
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x11A
_0xA7:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x11A:
	ST   -Y,R30
	RCALL SUBOPT_0x20
	CPI  R21,0
	BREQ _0xA9
	SUBI R21,LOW(1)
_0xA9:
	SUBI R19,LOW(1)
	RJMP _0xA4
_0xA6:
	RJMP _0xAA
_0xA3:
_0xAC:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x1E
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0xAE:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0xB0
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x1F
	RJMP _0xAE
_0xB0:
	CPI  R18,58
	BRLO _0xB1
	SBRS R16,3
	RJMP _0xB2
	SUBI R18,-LOW(7)
	RJMP _0xB3
_0xB2:
	SUBI R18,-LOW(39)
_0xB3:
_0xB1:
	SBRC R16,4
	RJMP _0xB5
	CPI  R18,49
	BRSH _0xB7
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0xB6
_0xB7:
	RJMP _0x11B
_0xB6:
	CP   R21,R19
	BRLO _0xBB
	SBRS R16,0
	RJMP _0xBC
_0xBB:
	RJMP _0xBA
_0xBC:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0xBD
	LDI  R18,LOW(48)
_0x11B:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0xBE
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x20
	CPI  R21,0
	BREQ _0xBF
	SUBI R21,LOW(1)
_0xBF:
_0xBE:
_0xBD:
_0xB5:
	RCALL SUBOPT_0x1A
	CPI  R21,0
	BREQ _0xC0
	SUBI R21,LOW(1)
_0xC0:
_0xBA:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0xAD
	RJMP _0xAC
_0xAD:
_0xAA:
	SBRS R16,0
	RJMP _0xC1
_0xC2:
	CPI  R21,0
	BREQ _0xC4
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x1C
	RJMP _0xC2
_0xC4:
_0xC1:
_0xC5:
_0x84:
_0x119:
	LDI  R17,LOW(0)
_0x6F:
	RJMP _0x6A
_0x6C:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S51:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x0:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _LcdSend

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R26,LOW(_LcdCache)
	LDI  R27,HIGH(_LcdCache)
	ADD  R26,R16
	ADC  R27,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDI  R31,0
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x5:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6:
	SUBI R30,LOW(-_lcd_buf)
	SBCI R31,HIGH(-_lcd_buf)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x8:
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	SBIW R30,1
	SUBI R30,LOW(-_LcdCache)
	SBCI R31,HIGH(-_LcdCache)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __MULW12
	MOVW R26,R30
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_table*2)
	SBCI R31,HIGH(-_table*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	LDD  R26,Y+2
	LDI  R30,LOW(15)
	SUB  R30,R26
	CP   R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	RCALL SUBOPT_0x6
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	RCALL __SAVELOCR4
	LDI  R16,0
	LDI  R18,0
	LDI  R19,0
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:50 WORDS
SUBOPT_0x10:
	LPM  R18,Z
	MOV  R30,R18
	ANDI R30,LOW(0x1)
	MOV  R26,R30
	LDI  R30,LOW(3)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R19,R30
	MOV  R30,R18
	ANDI R30,LOW(0x2)
	MOV  R26,R30
	LDI  R30,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	OR   R19,R30
	MOV  R30,R18
	ANDI R30,LOW(0x4)
	MOV  R26,R30
	LDI  R30,LOW(12)
	MUL  R30,R26
	MOVW R30,R0
	OR   R19,R30
	MOV  R30,R18
	ANDI R30,LOW(0x8)
	MOV  R26,R30
	LDI  R30,LOW(24)
	MUL  R30,R26
	MOVW R30,R0
	OR   R19,R30
	SWAP R18
	ANDI R18,0xF
	MOV  R30,R18
	ANDI R30,LOW(0x1)
	MOV  R26,R30
	LDI  R30,LOW(3)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R16,R30
	MOV  R30,R18
	ANDI R30,LOW(0x2)
	MOV  R26,R30
	LDI  R30,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	OR   R16,R30
	MOV  R30,R18
	ANDI R30,LOW(0x4)
	MOV  R26,R30
	LDI  R30,LOW(12)
	MUL  R30,R26
	MOVW R30,R0
	OR   R16,R30
	MOV  R30,R18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x11:
	ANDI R30,LOW(0x8)
	MOV  R26,R30
	LDI  R30,LOW(24)
	MUL  R30,R26
	MOVW R30,R0
	OR   R16,R30
	MOVW R30,R4
	SUBI R30,LOW(-_LcdCache)
	SBCI R31,HIGH(-_LcdCache)
	ST   Z,R19
	MOVW R30,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	__ADDW1MN _LcdCache,84
	ST   Z,R16
	MOVW R30,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13:
	RCALL _LcdClear
	RCALL _LcdUpdate
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(_lcd_buf)
	LDI  R31,HIGH(_lcd_buf)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x15:
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(1)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x16:
	__POINTW1FN _0,9
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _LcdStringBold
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x17:
	__POINTW1FN _0,17
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _LcdStringBig
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x18:
	__POINTW1FN _0,6
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _LcdStringBold
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x19:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	SUBI R30,-LOW(2)
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _LcdString
	RCALL _LcdUpdate
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x1A:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x1B:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1C:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1D:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x20:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
