//ATmega8
//4,000000 MHz

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+
#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib



//48x84 dots, 6x14 symbols

//LCD Port & pinout setup


//        

unsigned char lcd_buf[14];		//     LCD

//bit power_down = 0;			//power-down control: 0 - chip is active, 1 - chip is in PD-mode
//bit addressing = 0;			// : 0 - , 1- 


unsigned char  LcdCache [84	                          *48                            /8  ];	//Cache buffer in SRAM 84*48 bits or 504 bytes
unsigned int   LcdCacheIdx;              	//Cache index


// 
//void LcdChrBold (int ch);							                      ,   )
//void LcdStringBold (unsigned char x, unsigned char y);	    
//void LcdChrBig (int ch);							                      , 
//void LcdStringBig (unsigned char x, unsigned char y);		  

//ASCII
const char table[0x0500] =      //1280
{
0x00, 0x00, 0x00, 0x00, 0x00,// 00
0x00, 0x00, 0x5F, 0x00, 0x00,// 01
0x00, 0x07, 0x00, 0x07, 0x00,// 02
0x14, 0x7F, 0x14, 0x7F, 0x14,// 03
0x24, 0x2A, 0x7F, 0x2A, 0x12,// 04
0x23, 0x13, 0x08, 0x64, 0x62,// 05
0x36, 0x49, 0x55, 0x22, 0x50,// 06
0x00, 0x05, 0x03, 0x00, 0x00,// 07
0x00, 0x1C, 0x22, 0x41, 0x00,// 08
0x00, 0x41, 0x22, 0x1C, 0x00,// 09
0x14, 0x08, 0x3E, 0x08, 0x14,// 0A
0x08, 0x08, 0x3E, 0x08, 0x08,// 0B
0x00, 0x50, 0x30, 0x00, 0x00,// 0C
0x08, 0x08, 0x08, 0x08, 0x08,// 0D
0x00, 0x60, 0x60, 0x00, 0x00,// 0E
0x20, 0x10, 0x08, 0x04, 0x02,// 0F
0x00, 0x00, 0x00, 0x00, 0x00,// 10
0x00, 0x00, 0x5F, 0x00, 0x00,// 11
0x00, 0x07, 0x00, 0x07, 0x00,// 12
0x14, 0x7F, 0x14, 0x7F, 0x14,// 13
0x24, 0x2A, 0x7F, 0x2A, 0x12,// 14
0x23, 0x13, 0x08, 0x64, 0x62,// 15
0x36, 0x49, 0x55, 0x22, 0x50,// 16
0x00, 0x05, 0x03, 0x00, 0x00,// 17
0x00, 0x1C, 0x22, 0x41, 0x00,// 18
0x00, 0x41, 0x22, 0x1C, 0x00,// 19
0x14, 0x08, 0x3E, 0x08, 0x14,// 1A
0x08, 0x08, 0x3E, 0x08, 0x08,// 1B
0x00, 0x50, 0x30, 0x00, 0x00,// 1C
0x08, 0x08, 0x08, 0x08, 0x08,// 1D
0x00, 0x60, 0x60, 0x00, 0x00,// 1E
0x20, 0x10, 0x08, 0x04, 0x02,// 1F
0x00, 0x00, 0x00, 0x00, 0x00,// 20 space
0x00, 0x00, 0x5F, 0x00, 0x00,// 21 !
0x00, 0x07, 0x00, 0x07, 0x00,// 22 "
0x14, 0x7F, 0x14, 0x7F, 0x14,// 23 #
0x24, 0x2A, 0x7F, 0x2A, 0x12,// 24 $
0x23, 0x13, 0x08, 0x64, 0x62,// 25 %
0x36, 0x49, 0x55, 0x22, 0x50,// 26 &
0x00, 0x05, 0x03, 0x00, 0x00,// 27 '
0x00, 0x1C, 0x22, 0x41, 0x00,// 28 (
0x00, 0x41, 0x22, 0x1C, 0x00,// 29 )
0x14, 0x08, 0x3E, 0x08, 0x14,// 2a *
0x08, 0x08, 0x3E, 0x08, 0x08,// 2b +
0x00, 0x50, 0x30, 0x00, 0x00,// 2c ,
0x08, 0x08, 0x08, 0x08, 0x08,// 2d -
0x00, 0x60, 0x60, 0x00, 0x00,// 2e .
0x20, 0x10, 0x08, 0x04, 0x02,// 2f /
0x3E, 0x51, 0x49, 0x45, 0x3E,// 30 0
0x00, 0x42, 0x7F, 0x40, 0x00,// 31 1
0x42, 0x61, 0x51, 0x49, 0x46,// 32 2
0x21, 0x41, 0x45, 0x4B, 0x31,// 33 3
0x18, 0x14, 0x12, 0x7F, 0x10,// 34 4
0x27, 0x45, 0x45, 0x45, 0x39,// 35 5
0x3C, 0x4A, 0x49, 0x49, 0x30,// 36 6
0x01, 0x71, 0x09, 0x05, 0x03,// 37 7
0x36, 0x49, 0x49, 0x49, 0x36,// 38 8
0x06, 0x49, 0x49, 0x29, 0x1E,// 39 9
0x00, 0x36, 0x36, 0x00, 0x00,// 3a :
0x00, 0x56, 0x36, 0x00, 0x00,// 3b ;
0x08, 0x14, 0x22, 0x41, 0x00,// 3c <
0x14, 0x14, 0x14, 0x14, 0x14,// 3d =
0x00, 0x41, 0x22, 0x14, 0x08,// 3e >
0x02, 0x01, 0x51, 0x09, 0x06,// 3f ?
0x32, 0x49, 0x79, 0x41, 0x3E,// 40 @
0x7E, 0x11, 0x11, 0x11, 0x7E,// 41 A
0x7F, 0x49, 0x49, 0x49, 0x36,// 42 B
0x3E, 0x41, 0x41, 0x41, 0x22,// 43 C
0x7F, 0x41, 0x41, 0x22, 0x1C,// 44 D
0x7F, 0x49, 0x49, 0x49, 0x41,// 45 E
0x7F, 0x09, 0x09, 0x09, 0x01,// 46 F
0x3E, 0x41, 0x49, 0x49, 0x7A,// 47 G
0x7F, 0x08, 0x08, 0x08, 0x7F,// 48 H
0x00, 0x41, 0x7F, 0x41, 0x00,// 49 I
0x20, 0x40, 0x41, 0x3F, 0x01,// 4a J
0x7F, 0x08, 0x14, 0x22, 0x41,// 4b K
0x7F, 0x40, 0x40, 0x40, 0x40,// 4c L
0x7F, 0x02, 0x0C, 0x02, 0x7F,// 4d M
0x7F, 0x04, 0x08, 0x10, 0x7F,// 4e N
0x3E, 0x41, 0x41, 0x41, 0x3E,// 4f O
0x7F, 0x09, 0x09, 0x09, 0x06,// 50 P
0x3E, 0x41, 0x51, 0x21, 0x5E,// 51 Q
0x7F, 0x09, 0x19, 0x29, 0x46,// 52 R
0x46, 0x49, 0x49, 0x49, 0x31,// 53 S
0x01, 0x01, 0x7F, 0x01, 0x01,// 54 T
0x3F, 0x40, 0x40, 0x40, 0x3F,// 55 U
0x1F, 0x20, 0x40, 0x20, 0x1F,// 56 V
0x3F, 0x40, 0x38, 0x40, 0x3F,// 57 W
0x63, 0x14, 0x08, 0x14, 0x63,// 58 X
0x07, 0x08, 0x70, 0x08, 0x07,// 59 Y
0x61, 0x51, 0x49, 0x45, 0x43,// 5a Z
0x00, 0x7F, 0x41, 0x41, 0x00,// 5b [
0x02, 0x04, 0x08, 0x10, 0x20,// 5c Yen Currency Sign
0x00, 0x41, 0x41, 0x7F, 0x00,// 5d ]
0x04, 0x02, 0x01, 0x02, 0x04,// 5e ^
0x40, 0x40, 0x40, 0x40, 0x40,// 5f _
0x00, 0x01, 0x02, 0x04, 0x00,// 60 `
0x20, 0x54, 0x54, 0x54, 0x78,// 61 a
0x7F, 0x48, 0x44, 0x44, 0x38,// 62 b
0x38, 0x44, 0x44, 0x44, 0x20,// 63 c
0x38, 0x44, 0x44, 0x48, 0x7F,// 64 d
0x38, 0x54, 0x54, 0x54, 0x18,// 65 e
0x08, 0x7E, 0x09, 0x01, 0x02,// 66 f
0x0C, 0x52, 0x52, 0x52, 0x3E,// 67 g
0x7F, 0x08, 0x04, 0x04, 0x78,// 68 h
0x00, 0x44, 0x7D, 0x40, 0x00,// 69 i
0x20, 0x40, 0x44, 0x3D, 0x00,// 6a j
0x7F, 0x10, 0x28, 0x44, 0x00,// 6b k
0x00, 0x41, 0x7F, 0x40, 0x00,// 6c l
0x7C, 0x04, 0x18, 0x04, 0x78,// 6d m
0x7C, 0x08, 0x04, 0x04, 0x78,// 6e n
0x38, 0x44, 0x44, 0x44, 0x38,// 6f o
0x7C, 0x14, 0x14, 0x14, 0x08,// 70 p
0x08, 0x14, 0x14, 0x18, 0x7C,// 71 q
0x7C, 0x08, 0x04, 0x04, 0x08,// 72 r
0x48, 0x54, 0x54, 0x54, 0x20,// 73 s
0x04, 0x3F, 0x44, 0x40, 0x20,// 74 t
0x3C, 0x40, 0x40, 0x20, 0x7C,// 75 u
0x1C, 0x20, 0x40, 0x20, 0x1C,// 76 v
0x3C, 0x40, 0x30, 0x40, 0x3C,// 77 w
0x44, 0x28, 0x10, 0x28, 0x44,// 78 x
0x0C, 0x50, 0x50, 0x50, 0x3C,// 79 y
0x44, 0x64, 0x54, 0x4C, 0x44,// 7a z
0x00, 0x08, 0x36, 0x41, 0x00,// 7b <
0x00, 0x00, 0x7F, 0x00, 0x00,// 7c |
0x00, 0x41, 0x36, 0x08, 0x00,// 7d >
0x10, 0x08, 0x08, 0x10, 0x08,// 7e Right Arrow ->
0x78, 0x46, 0x41, 0x46, 0x78,// 7f Left Arrow <-
0x00, 0x00, 0x00, 0x00, 0x00,// 80
0x00, 0x00, 0x5F, 0x00, 0x00,// 81
0x00, 0x07, 0x00, 0x07, 0x00,// 82
0x14, 0x7F, 0x14, 0x7F, 0x14,// 83
0x24, 0x2A, 0x7F, 0x2A, 0x12,// 84
0x23, 0x13, 0x08, 0x64, 0x62,// 85
0x36, 0x49, 0x55, 0x22, 0x50,// 86
0x00, 0x05, 0x03, 0x00, 0x00,// 87
0x00, 0x1C, 0x22, 0x41, 0x00,// 88
0x00, 0x41, 0x22, 0x1C, 0x00,// 89
0x14, 0x08, 0x3E, 0x08, 0x14,// 8A
0x08, 0x08, 0x3E, 0x08, 0x08,// 8B
0x00, 0x50, 0x30, 0x00, 0x00,// 8C
0x08, 0x08, 0x08, 0x08, 0x08,// 8D
0x00, 0x60, 0x60, 0x00, 0x00,// 8E
0x20, 0x10, 0x08, 0x04, 0x02,// 8F
0x00, 0x00, 0x00, 0x00, 0x00,// 90
0x00, 0x00, 0x5F, 0x00, 0x00,// 91
0x00, 0x07, 0x00, 0x07, 0x00,// 92
0x14, 0x7F, 0x14, 0x7F, 0x14,// 93
0x24, 0x2A, 0x7F, 0x2A, 0x12,// 94
0x23, 0x13, 0x08, 0x64, 0x62,// 95
0x36, 0x49, 0x55, 0x22, 0x50,// 96
0x00, 0x05, 0x03, 0x00, 0x00,// 97
0x00, 0x1C, 0x22, 0x41, 0x00,// 98
0x00, 0x41, 0x22, 0x1C, 0x00,// 99
0x14, 0x08, 0x3E, 0x08, 0x14,// 9A
0x08, 0x08, 0x3E, 0x08, 0x08,// 9B
0x00, 0x50, 0x30, 0x00, 0x00,// 9C
0x08, 0x08, 0x08, 0x08, 0x08,// 9D
0x00, 0x60, 0x60, 0x00, 0x00,// 9E
0x20, 0x10, 0x08, 0x04, 0x02,// 9F
0x00, 0x00, 0x00, 0x00, 0x00,// A0
0x00, 0x00, 0x5F, 0x00, 0x00,// A1
0x00, 0x07, 0x00, 0x07, 0x00,// A2
0x14, 0x7F, 0x14, 0x7F, 0x14,// A3
0x24, 0x2A, 0x7F, 0x2A, 0x12,// A4
0x23, 0x13, 0x08, 0x64, 0x62,// A5
0x36, 0x49, 0x55, 0x22, 0x50,// A6
0x00, 0x05, 0x03, 0x00, 0x00,// A7
0x00, 0x1C, 0x22, 0x41, 0x00,// A8
0x00, 0x41, 0x22, 0x1C, 0x00,// A9
0x14, 0x08, 0x3E, 0x08, 0x14,// AA
0x08, 0x08, 0x3E, 0x08, 0x08,// AB
0x00, 0x50, 0x30, 0x00, 0x00,// AC
0x08, 0x08, 0x08, 0x08, 0x08,// AD
0x00, 0x60, 0x60, 0x00, 0x00,// AE
0x20, 0x10, 0x08, 0x04, 0x02,// AF
0x3E, 0x51, 0x49, 0x45, 0x3E,// B0
0x00, 0x42, 0x7F, 0x40, 0x00,// B1
0x42, 0x61, 0x51, 0x49, 0x46,// B2
0x21, 0x41, 0x45, 0x4B, 0x31,// B3
0x18, 0x14, 0x12, 0x7F, 0x10,// B4
0x27, 0x45, 0x45, 0x45, 0x39,// B5
0x3C, 0x4A, 0x49, 0x49, 0x30,// B6
0x01, 0x71, 0x09, 0x05, 0x03,// B7
0x36, 0x49, 0x49, 0x49, 0x36,// B8
0x06, 0x49, 0x49, 0x29, 0x1E,// B9
0x00, 0x36, 0x36, 0x00, 0x00,// BA
0x00, 0x56, 0x36, 0x00, 0x00,// BB
0x08, 0x14, 0x22, 0x41, 0x00,// BC
0x14, 0x14, 0x14, 0x14, 0x14,// BD
0x00, 0x41, 0x22, 0x14, 0x08,// BE
0x02, 0x01, 0x51, 0x09, 0x06,// BF
0x7E, 0x11, 0x11, 0x11, 0x7E,// C0 ?
0x7F, 0x49, 0x49, 0x49, 0x31,// C1 ?
0x7F, 0x49, 0x49, 0x49, 0x36,// C2 ?
0x7F, 0x01, 0x01, 0x01, 0x03,// C3 ?
0x70, 0x29, 0x27, 0x21, 0x7F,// C4 ?
0x7F, 0x49, 0x49, 0x49, 0x41,// C5 ?
0x77, 0x08, 0x7F, 0x08, 0x77,// C6 ?
0x41, 0x41, 0x41, 0x49, 0x76,// C7 ?
0x7F, 0x10, 0x08, 0x04, 0x7F,// C8 ?
0x7F, 0x10, 0x09, 0x04, 0x7F,// C9 ?
0x7F, 0x08, 0x14, 0x22, 0x41,// CA ?
0x20, 0x41, 0x3F, 0x01, 0x7F,// CB ?
0x7F, 0x02, 0x0C, 0x02, 0x7F,// CC ?
0x7F, 0x08, 0x08, 0x08, 0x7F,// CD ?
0x3E, 0x41, 0x41, 0x41, 0x3E,// CE ?
0x7F, 0x01, 0x01, 0x01, 0x7F,// CF ?
0x7F, 0x09, 0x09, 0x09, 0x06,// D0 ?
0x3E, 0x41, 0x41, 0x41, 0x22,// D1 ?
0x01, 0x01, 0x7F, 0x01, 0x01,// D2 ?
0x47, 0x28, 0x10, 0x08, 0x07,// D3 ?
0x1E, 0x21, 0x7F, 0x21, 0x1E,// D4 ?
0x63, 0x14, 0x08, 0x14, 0x63,// D5 ?
0x3F, 0x20, 0x20, 0x20, 0x5F,// D6 ?
0x07, 0x08, 0x08, 0x08, 0x7F,// D7 ?
0x7F, 0x40, 0x7F, 0x40, 0x7F,// D8 ?
0x3F, 0x20, 0x3F, 0x20, 0x5F,// D9 ?
0x01, 0x7F, 0x48, 0x48, 0x30,// DA ?
0x7F, 0x48, 0x30, 0x00, 0x7F,// DB ?
0x00, 0x7F, 0x48, 0x48, 0x30,// DC ?
0x41, 0x41, 0x41, 0x49, 0x3E,// DD ?
0x7F, 0x08, 0x3E, 0x41, 0x3E,// DE ?
0x46, 0x29, 0x19, 0x09, 0x7F,// DF ?
0x20, 0x54, 0x54, 0x54, 0x78,// E0 ?
0x3C, 0x4A, 0x4A, 0x49, 0x31,// E1 ?
0x7C, 0x54, 0x54, 0x28, 0x00,// E2 ?
0x7C, 0x04, 0x04, 0x04, 0x0C,// E3 ?
0x72, 0x2A, 0x26, 0x22, 0x7E,// E4 ?
0x38, 0x54, 0x54, 0x54, 0x18,// E5 ?
0x6C, 0x10, 0x7C, 0x10, 0x6C,// E6 ?
0x44, 0x44, 0x54, 0x54, 0x38,// E7 ?
0x7C, 0x20, 0x10, 0x08, 0x7C,// E8 ?
0x7C, 0x21, 0x12, 0x09, 0x7C,// E9 ?
0x7C, 0x10, 0x28, 0x44, 0x00,// EA ?
0x20, 0x44, 0x3C, 0x04, 0x7C,// EB ?
0x7C, 0x08, 0x10, 0x08, 0x7C,// EC ?
0x7C, 0x10, 0x10, 0x10, 0x7C,// ED ?
0x38, 0x44, 0x44, 0x44, 0x38,// EE ?
0x7C, 0x04, 0x04, 0x04, 0x7C,// EF ?
0x7C, 0x14, 0x14, 0x14, 0x08,// F0 ?
0x38, 0x44, 0x44, 0x44, 0x20,// F1 ?
0x04, 0x04, 0x7C, 0x04, 0x04,// F2 ?
0x44, 0x28, 0x10, 0x08, 0x04,// F3 ?
0x08, 0x14, 0x7E, 0x14, 0x08,// F4 ?
0x44, 0x28, 0x10, 0x28, 0x44,// F5 ?
0x3C, 0x40, 0x40, 0x7C, 0x40,// F6 ?
0x0C, 0x10, 0x10, 0x10, 0x7C,// F7 ?
0x7C, 0x40, 0x7C, 0x40, 0x7C,// F8 ?
0x3C, 0x20, 0x3C, 0x20, 0x7C,// F9 ?
0x04, 0x7C, 0x50, 0x50, 0x20,// FA ?
0x7C, 0x50, 0x20, 0x00, 0x7C,// FB ?
0x00, 0x7C, 0x50, 0x50, 0x20,// FC ?
0x28, 0x44, 0x44, 0x54, 0x38,// FD ?
0x7C, 0x10, 0x38, 0x44, 0x38,// FE ?
0x48, 0x54, 0x34, 0x14, 0x7C }; // FF

void LcdSend (unsigned char data, unsigned char cmd)    //Sends data to display controller
{
  PORTB.1    = 0;                              //Enable display controller (active low)

  if (cmd) PORTB.2    = 1;	                    //   

    else PORTB.2    = 0;
    SPDR = data;                                          //Send data to display controller

  while ( (SPSR & 0x80) != 0x80 );                      //Wait until Tx register empty
  PORTB.1    = 1;                              //Disable display controller
}

void LcdUpdate (void)                                   //Copies the LCD cache into the device RAM
{
  int i;
  char j;

  LcdSend(0x80, 0);		//      0,0
  LcdSend(0x40, 0);

  for (i = 0; i < 84	                          *48                            /8  ; i++)		// 
  {
    LcdSend(LcdCache[i], 1);
  }
}

void LcdClear (void)    //Clears the display
  {
    int i;

	  for (i = 0; i < 84	                          *48                            /8  ; i++) LcdCache[i] = 0;	//   0
	  LcdUpdate ();
   }


void LcdInit ( void )	// SPI  
{
  PORTB.0    = 1;       //  /
  DDRB.0    = DDRB.2    = DDRB.1    = DDRB.3    = DDRB.5    = 1;
  delay_ms(1);
  SPCR = 0x50;
  PORTB.0    = 0;       // 
  delay_ms(10);
  PORTB.0    = 1;
                            
  PORTB.1    = 1;        //Disable LCD controller

  LcdSend( 0x21, 0 ); 			//LCD Extended Commands
  LcdSend( 0x06, 0 ); 			//Set Temp coefficent
  LcdSend( 0x13, 0 ); 			//LCD bias mode 1:48
  LcdSend( 0xC8, 0 ); 			//Set LCD Vop (Contrast)
  LcdSend (0x20, 0);              //Horizontal addressing mode.  
	LcdSend (0x0C, 0);              //normal mode.              
  
  LcdClear();
};

void LcdPixel (unsigned char x, unsigned char y, unsigned char mode)     //Displays a pixel at given absolute (x, y) location, mode -> Off, On or Xor
{
  int index;
  unsigned char offset, data;

  if ( x > 84	                           ) return;	//     - 
  if ( y > 48                             ) return;

  index = (((int)(y)/8)*84)+x;    //      
  offset  = y-((y/8)*8);          //     

  data = LcdCache[index];         //    

  LcdCache[index] = data;		//  
}

void LcdGotoXYFont (unsigned char x, unsigned char y)   //Sets cursor location to xy location. Range: 1,1 .. 14,6
{
  if (x <= 14 && y<= 6) LcdCacheIdx = ( (int)(y) - 1 ) * 84 + ( (int)(x) - 1 ) * 6;
}

void clean_lcd_buf (void)	//  
{
  char i;

  for (i=0; i<14; i++) lcd_buf[i] = 0;
}

void LcdChr (int ch)	//Displays a character at current cursor location and increment cursor location
{
  unsigned char i;

  for ( i = 0; i < 5; i++ ) LcdCache[LcdCacheIdx++] = table[(ch*5+i)];	// -       - 5 
  LcdCache[LcdCacheIdx++] = 0x00;	//   
}

void LcdString (unsigned char x, unsigned char y)	//Displays a string at current cursor location
{
  unsigned char i;

  if (x > 14 && y > 6) return;
  LcdGotoXYFont (x, y);
  for ( i = 0; i < 15-x; i++ ) if (lcd_buf[i]) LcdChr (lcd_buf[i]);
  clean_lcd_buf();
}

void LcdChrBold (int ch)	//Displays a bold character at current cursor location and increment cursor location
{
  unsigned char i;
  unsigned char a = 0, b = 0, c = 0;

  for ( i = 0; i < 5; i++ )
{
  c = table[(ch*5+i)];		        //   

  b =  (c & 0x01) * 3;            //""    
  b |= (c & 0x02) * 6;
  b |= (c & 0x04) * 12;
  b |= (c & 0x08) * 24;

  c >>= 4;
  a =  (c & 0x01) * 3;
  a |= (c & 0x02) * 6;
  a |= (c & 0x04) * 12;
  a |= (c & 0x08) * 24;

  LcdCache[LcdCacheIdx] = b;	    //    
  LcdCache[LcdCacheIdx+1] = b;    //    
  LcdCache[LcdCacheIdx+84] = a;
  LcdCache[LcdCacheIdx+85] = a;
  LcdCacheIdx = LcdCacheIdx+2;
  }

  LcdCache[LcdCacheIdx++] = 0x00;	//   
  LcdCache[LcdCacheIdx++] = 0x00;
 	}

void LcdStringBold (unsigned char x, unsigned char y)	//Displays a string at current cursor location
{
unsigned char i;

if (x > 13 && y > 5) return;
LcdGotoXYFont (x, y);
for ( i = 0; i < 14-x; i++ ) if (lcd_buf[i]) LcdChrBold (lcd_buf[i]);
clean_lcd_buf();
}

void LcdChrBig (int ch)	//Displays a character at current cursor location and increment cursor location
{
  unsigned char i;
  unsigned char a = 0, b = 0, c = 0;

  for ( i = 0; i < 5; i++ )
{
  c = table[(ch*5+i)];		//   

  b =  (c & 0x01) * 3;            //""    
  b |= (c & 0x02) * 6;
  b |= (c & 0x04) * 12;
  b |= (c & 0x08) * 24;

  c >>= 4;
  a =  (c & 0x01) * 3;
  a |= (c & 0x02) * 6;
  a |= (c & 0x04) * 12;
  a |= (c & 0x08) * 24;
  LcdCache[LcdCacheIdx] = b;
  LcdCache[LcdCacheIdx+84] = a;
  LcdCacheIdx = LcdCacheIdx+1;
}

  LcdCache[LcdCacheIdx++] = 0x00;
}

void LcdStringBig (unsigned char x, unsigned char y)	//Displays a string at current cursor location
{
  unsigned char i;

  if (x > 14 && y > 5) return;
  LcdGotoXYFont (x, y);
  for ( i = 0; i < 15-x; i++ ) if (lcd_buf[i]) LcdChrBig (lcd_buf[i]);
  clean_lcd_buf();
}

void main(void)
{
  char i;

  LcdInit();

  while (1)
  {

  LcdClear();
  LcdUpdate();
  delay_ms(2000);
  LcdClear();
  LcdUpdate();
  delay_ms(2000);

  LcdClear();
	
	for (i=0; i<10; i++)
		{
		  sprintf (lcd_buf, "=%u", i);
		  LcdString(1,1);
		  sprintf (lcd_buf, "=%u", i);  // 1
		  LcdStringBold(1,2);
		  sprintf (lcd_buf, "Bufe=%u/", i); //1 
		  LcdStringBig(1,4);
		  sprintf (lcd_buf, "%u", i);
		  LcdStringBold(9,4);
	    sprintf (lcd_buf, "Bufer=%u ", i+2); //sprintf (lcd_buf, "=%u ", i+2);
	    LcdString(1,6);
		  LcdUpdate();

		  delay_ms(300);
		}
		
	for (i=0; i<10; i++)
		{
		  sprintf (lcd_buf, "=%u", i);
		  LcdString(1,1);
		  sprintf (lcd_buf, "=%u", i);  // 2
		  LcdStringBold(1,2);
		  sprintf (lcd_buf, "Bufe=%u/", i); //1 
		  LcdStringBig(1,4);
		  sprintf (lcd_buf, "%u", i);
		  LcdStringBold(9,4);
	    sprintf (lcd_buf, "=%u ", i+2);
	    LcdString(1,6);
		  LcdUpdate();

		  delay_ms(300);
		}
	};
}
